//+------------------------------------------------------------------+
//|                                                 MACD colored.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
//mod + sto  + baseMAPeriod    ki

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers  7
#property indicator_color1   Green
#property indicator_color2   Green
#property indicator_color3   Red
#property indicator_color4   Red
#property indicator_color5   Gray
#property indicator_color6   Gold
#property indicator_color7   DimGray
#property indicator_width1   1
#property indicator_width2   2
#property indicator_width3   1
#property indicator_width4   2
#property indicator_width5   2
#property indicator_width6   1

extern string _            = "MACD settings";
extern int    FastEMA      = 12;
extern int    SlowEMA      = 26;
extern int    SignalEMA    = 9;
extern int    PriceType    = PRICE_CLOSE;

//
//
//
//
//
extern bool ShowHisto = true;
extern bool ShowOSMA  = false;
extern int  OsmaMultiplier = 2;
extern bool ShowLines = true;//if falce - osma autoscale
extern int  RSIPeriod = 14;
extern int  MOMPeriod = 14;
extern int  CCIPeriod = 10;

extern int StoK_period     = 14;
extern int StoD_period     = 3;
extern int StoSl_period    = 3;
extern int StoPriceField   = 0;
extern int StoMain_MaMode  = 0;
extern int StoSig_MaMode   = 0;

extern int  baseMaPeriod   = 1;
extern int  baseMaMode     = 0;

//
//
//
//
//

extern int  MACDType  = 0;

extern string  note_MACD_Types_     = "0 regularMACD-ema 1ZeroLagMACD 2MACDofRSI  3MACDofMomentum 4MACDofCCI 5MACDofStochastic";
extern string  Sto_PriceField_      = "0Low/High  1Close/Close";


extern string  __              = "alerts";
extern bool    alertsOn        = true;
extern bool    MACDalerts      = true;
extern bool    OsMAalerts      = true;
extern bool    alertsMessage   = true;
extern bool    alertsSound     = true;
extern bool    alertsEmail     = false;
extern string  soundfile       = "news.wav";     //"alert2.wav"


//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];
string IndicatorName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,buffer7);
   SetIndexBuffer(7,buffer8);
   
   if (ShowOSMA)
   {
         ShowHisto = true;
         SetIndexStyle(6,DRAW_LINE);
   }         
   else  SetIndexStyle(6,DRAW_NONE);
   if (ShowHisto)
   {
      SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexStyle(3,DRAW_HISTOGRAM);
   }
   else
   {
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
   }      
   
   if (ShowLines)
   {
         SetIndexStyle(4,DRAW_LINE);
         SetIndexStyle(5,DRAW_LINE);
   }         
   else  
   {
         SetIndexStyle(4,DRAW_NONE);
         SetIndexStyle(5,DRAW_NONE);
   }
   //
   //
   //
   //
   //
   
   string ShortName;
   if  (MACDType==1)
         ShortName = "ZeroLag MACD (";
   else  ShortName = "MACD (";
         ShortName = ShortName+FastEMA+","+SlowEMA+","+SignalEMA+")";
         switch (MACDType)
         {
            case 2: ShortName = ShortName+" of RSI       ("+RSIPeriod+")"; break;
            case 3: ShortName = ShortName+" of Momentum  ("+MOMPeriod+")"; break;
            case 4: ShortName = ShortName+" of CCI       ("+CCIPeriod+")"; break;
            case 5: ShortName = ShortName+" of Stochastic("+StoK_period+","+StoD_period+","+StoSl_period+")"; break;
 
         }
         IndicatorShortName(ShortName);

   //
   //
   //
   //
   //

   IndicatorName = WindowExpertName();
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double signalAlpha = 2.0/(1.0+SignalEMA);
   int  counted_bars  = IndicatorCounted();
   int  i,limit; 
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      limit = Bars - counted_bars;

   //
   //
   //
   //
   //

   if (_ == "DoingZeroLag")  { CalculateZeroLag(limit); return(0); }
   
   //
   //
   //
   //
   //
                  
   for(i = limit; i >= 0 ; i--)
   {
      switch (MACDType)
      {
         case 2:  buffer8[i] = iRSI(NULL,0,RSIPeriod,PriceType,i);      break;
         case 3:  buffer8[i] = iMomentum(NULL,0,MOMPeriod,PriceType,i); break;
         case 4:  buffer8[i] = iCCI(NULL,0,CCIPeriod,PriceType,i);      break;
         case 5:  buffer8[i] = iStochastic(NULL,0,StoK_period,StoD_period,StoSl_period,StoMain_MaMode,StoPriceField,0,i);   break;

         default: buffer8[i] = iMA(NULL,0,baseMaPeriod,0,baseMaMode,PriceType,i);    break;
      }               
      
   }
   
   for(i = limit; i >= 0 ; i--)
   {
      if (MACDType == 1)
      {
         buffer5[i] = iCustom(NULL,0,IndicatorName,"DoingZeroLag",FastEMA,SlowEMA,SignalEMA,PriceType,0,i);
         buffer6[i] = iCustom(NULL,0,IndicatorName,"DoingZeroLag",FastEMA,SlowEMA,SignalEMA,PriceType,1,i);
      }               



      else
      {
         buffer5[i] = iMAOnArray(buffer8,0,FastEMA,0,MODE_EMA,i)-
                      iMAOnArray(buffer8,0,SlowEMA,0,MODE_EMA,i);
         buffer6[i] = buffer6[i+1]+ signalAlpha*(buffer5[i]-buffer6[i+1]);
      }            

      //
      //
      //
      //
      //
                          
      buffer1[i]= EMPTY_VALUE;
      buffer2[i]= EMPTY_VALUE;
      buffer3[i]= EMPTY_VALUE;
      buffer4[i]= EMPTY_VALUE;
      if (!ShowOSMA)
         {
            if (buffer5[i]>0) 
               {
                  if (buffer5[i]>buffer5[i+1]) 
                        buffer2[i]=buffer5[i];
                  else  buffer1[i]=buffer5[i];
               }            
            else    
               {         
                  if (buffer5[i]<buffer5[i+1]) 
                        buffer4[i]=buffer5[i];
                  else  buffer3[i]=buffer5[i];
              }
         }
      else
         {
            buffer7[i] = (buffer5[i]-buffer6[i])*OsmaMultiplier;
            if (buffer7[i]>0) 
               {
                  if (buffer7[i]>buffer7[i+1]) 
                        buffer2[i]=buffer7[i];
                  else  buffer1[i]=buffer7[i];
               }            
            else    
               {         
                  if (buffer7[i]<buffer7[i+1]) 
                        buffer4[i]=buffer7[i];
                  else  buffer3[i]=buffer7[i];
              }
         }
   }

   //
   //
   //
   //
   //

   if (alertsOn)
   {
      //
      //
      //
      //
      //
     
     if(MACDalerts)
      {       
      if (buffer5[0]>0 && buffer5[1]<0) doAlert("macd line crossed 0 up "); 
      if (buffer5[0]<0 && buffer5[1]>0) doAlert("macd line crossed 0 down "); 
      }
     
     if (OsMAalerts||MACDalerts)
      { 
      if (buffer6[0]<buffer5[0] && buffer6[1] > buffer5[1]) doAlert("osma crossed 0 (macd crossed signal line) up "); 
      if (buffer6[0]>buffer5[0] && buffer6[1] < buffer5[1]) doAlert("osma crossed 0 (macd crossed signal line) down "); 
      }
     
     if (OsMAalerts)
      {
      if (buffer7[0]>buffer7[1] && buffer7[2] > buffer7[1]) doAlert("osma macd(histo)changed direction: up "); 
      if (buffer7[0]<buffer7[1] && buffer7[2] < buffer7[1]) doAlert("osma macd(histo)changed direction: down "); 
      }


   }   
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CalculateZeroLag(int limit)
{
   int    i;
   double maf,mas;
   
   //
   //
   //
   //
   //
   
   for(i=limit;i>=0;i--)
   {
      buffer3[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PriceType,i);
      buffer4[i]=iMA(NULL,0,SlowEMA,0,MODE_EMA,PriceType,i);
   }
   for(i=limit;i>=0;i--)
   {
      maf=buffer3[i]+buffer3[i]-iMAOnArray(buffer3,0,FastEMA,0,MODE_EMA,i);
      mas=buffer4[i]+buffer4[i]-iMAOnArray(buffer4,0,SlowEMA,0,MODE_EMA,i);
          buffer1[i]=maf-mas;
   }
   
   //
   //
   //
   //
   //
   
   for(i=limit;i>=0;i--) buffer5[i]=                      iMAOnArray(buffer1,0,SignalEMA,0,MODE_EMA,i);
   for(i=limit;i>=0;i--) buffer2[i]=buffer5[i]+buffer5[i]-iMAOnArray(buffer5,0,SignalEMA,0,MODE_EMA,i);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string forWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != forWhat || previousTime != Time[0]) {
       previousAlert  = forWhat;
       previousTime   = Time[0];
       message        = StringConcatenate(Symbol()," ",forWhat," at ",TimeToStr(TimeLocal(),TIME_SECONDS));
           if (alertsMessage) Alert(message);
           if (alertsSound)   PlaySound(soundfile);
           if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MACD crossing"),message);
   }           
}

