//+------------------------------------------------------------------+
//|                                           MACD(DEMA)DiNapoli.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
//mod2008fxtsd 4c histo ki
#property copyright "Copyright  2005, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  Green
#property  indicator_color2  DarkGreen
#property  indicator_color3  Red
#property  indicator_color4  Red

#property  indicator_color5  DarkSlateGray
#property  indicator_color6  Gold

#property  indicator_width1  2
#property  indicator_width4  2

//---- indicator parameters
extern double FastEMA=8.3896;
extern double SlowEMA=17.5185;
extern double SignalEMA=9.0503;

extern bool drawMACDLine = false;
//---- indicator buffers
double     Macd_buffer[];
double     Sign_buffer[];
double     Fast_buffer[];
double     Slow_buffer[];

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(8);
   
      SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);

if (drawMACDLine)int drawMACDstyle=DRAW_LINE; 
            else     drawMACDstyle=DRAW_NONE;
   SetIndexBuffer (4,Macd_buffer);  
   SetIndexStyle  (4,drawMACDstyle);
 
   SetIndexBuffer(5,Sign_buffer);
   SetIndexBuffer(6,Fast_buffer);
   SetIndexBuffer(7,Slow_buffer);
 
   //SetIndexDrawBegin(0,Bars-1);
   //SetIndexDrawBegin(1,Bars-1);
   //IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- indicator buffers mapping
   if(!SetIndexBuffer(4,Macd_buffer) && !SetIndexBuffer(5,Sign_buffer))
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD(DEMA)DiNapoli ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
 
   SetIndexLabel(4,"MACD(DEMA)");
   SetIndexLabel(5,"Signal");
     
     SetIndexLabel(0,"");
     SetIndexLabel(1,"");
     SetIndexLabel(2,"");
     SetIndexLabel(3,"");
     SetIndexLabel(6,"");
     SetIndexLabel(7,"");

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|  MACD (DEMA) DiNapoli                                            |
//+------------------------------------------------------------------+
int start()
  {
   

   for(int i=Bars; i>=0; i--)
      {
      Fast_buffer[i]=0.0;
      Slow_buffer[i]=0.0;
      Macd_buffer[i]=0.0;
      Sign_buffer[i]=0.0;
      if (i==Bars) {Fast_buffer[i]=Close[i];Slow_buffer[i]=Close[i];} 
      }
//---- macd counted in the 1-st buffer      
   for( i=Bars-1; i>=0; i--)
      {
      Fast_buffer[i]=Fast_buffer[i+1]+2.0/(1.0+FastEMA)*(Close[i]-Fast_buffer[i+1]);
      Slow_buffer[i]=Slow_buffer[i+1]+2.0/(1.0+SlowEMA)*(Close[i]-Slow_buffer[i+1]);
      Macd_buffer[i]=Fast_buffer[i]-Slow_buffer[i];
      }
//---- signal line counted in the 2-nd buffer
   for(i=Bars-1; i>=0; i--)
   
    Sign_buffer[i]=Sign_buffer[i+1]+2.0/(1.0+SignalEMA)*(Macd_buffer[i]-Sign_buffer[i+1]);

//----

   for(i=Bars-1; i>=0; i--)
      {

         if(Macd_buffer[i]==Macd_buffer[i+1])
            {
               buffer1[i]=buffer1[i+1];
               buffer2[i]=buffer2[i+1];
               buffer3[i]=buffer3[i+1];
               buffer4[i]=buffer4[i+1];
               continue;
            }

            buffer1[i]=EMPTY_VALUE;
            buffer2[i]=EMPTY_VALUE;
            buffer3[i]=EMPTY_VALUE;
            buffer4[i]=EMPTY_VALUE;
 
            if(Macd_buffer[i]<0)
               {
                  if (Macd_buffer[i]<Macd_buffer[i+1]) buffer3[i]=Macd_buffer[i];
                  if (Macd_buffer[i]>Macd_buffer[i+1]) buffer4[i]=Macd_buffer[i];
               }
            if(Macd_buffer[i]>0)
               {
                  if (Macd_buffer[i]<Macd_buffer[i+1]) buffer2[i]=Macd_buffer[i];
                  if (Macd_buffer[i]>Macd_buffer[i+1]) buffer1[i]=Macd_buffer[i];
               }
      }

//---- done

   return(0);
  }