//+------------------------------------------------------------------+
//|                                         Need4Speed_Histogram.mq4 |
//|                                  Copyright 2015, Khalil Abokwaik |
//|                             http://www.forexfactory.com/abokwaik |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2015, Khalil Abokwaik"
#property link        "http://www.forexfactory.com/abokwaik"
#property description "Need4Speed Histogram by Khalil Abokwaik"
#property strict

//--- indicator settings
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 clrOrange
#property indicator_color2 clrLime
//#property indicator_color3 Yellow
//--- input parameter
input int      speed_max         =  20;          //Speed Threshold (Points or Pips)
input int      speed_timer       =  1;          //Time (Seconds)
input int      alert_on_count    =  1;//Alert when Bull or Bear Excceds Count
input bool     play_sounds       =  True;       //Play Sounds
input bool     show_alerts       =  False;//Show Alerts

//--- buffers
double ExtBearsBuffer[];
double ExtBullsBuffer[];
//double ExtMaxBuffer[];
//
double      prev_price =0.0;
int         prev_speed = 0;
int         zcorner = 0;
int         curr_speed = 0,up_signals=0,down_signals=0,max_bull_speed=0,max_bear_speed=0;
int         up_lab_cnt =0;
int         down_lab_cnt =0,maxx_speed=0;
datetime    old_time=0,old_time2=0;
int         pb_up=0,pb_down=0;
int         bar_max_speed=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init()
{
   string short_name;
//--- 1 additional buffer used for counting.
   IndicatorBuffers(3);
   IndicatorDigits(0);
//--- indicator line
   
   SetIndexStyle(0,DRAW_HISTOGRAM,0,ChartGetInteger(0,CHART_SCALE));
   SetIndexBuffer(0,ExtBearsBuffer);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,ChartGetInteger(0,CHART_SCALE));   
   SetIndexBuffer(1,ExtBullsBuffer);
//   SetIndexStyle(2,DRAW_LINE);   
//   SetIndexBuffer(2,ExtMaxBuffer);
   
//--- name for DataWindow and indicator subwindow label
   short_name="Need4Speed ("+IntegerToString(speed_max)+"/"+IntegerToString(speed_timer)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Bears");
   SetIndexLabel(1,"Bulls");
   IndicatorSetInteger(INDICATOR_LEVELS,1);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0);

   //if(!EventSetTimer(speed_timer)) Alert("Error in Creating Timer");
   prev_price=0.0;
   prev_speed = 0;
   curr_speed = 0;
   max_bull_speed=0;
   max_bear_speed=0;
   
  }
//+------------------------------------------------------------------+
//| 
//+------------------------------------------------------------------+
/*int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
                */
  int start()
  {
   if(TimeCurrent()-old_time2>speed_timer)
   {   Update_Indi();
      old_time2=TimeCurrent();
   }
   //return(rates_total);
   return(0);
  }
//+------------------------------------------------------------------+

int deinit()
{
   //EventKillTimer();
   //delete_interface();   
   return(0);
   
}
//------------------------------------------------------
/*void OnTimer()
  {
//---
   RefreshRates();
   Update_Indi();
  }
*/
//+------------------------------------------------------------------+

void Update_Indi()
{
   SetIndexStyle(0,DRAW_HISTOGRAM,0,ChartGetInteger(0,CHART_SCALE));
   SetIndexStyle(1,DRAW_HISTOGRAM,0,ChartGetInteger(0,CHART_SCALE));   

   RefreshRates();
   if(Time[0]>old_time)
   {
      old_time=TimeCurrent();      
      up_signals=0;
      down_signals=0;
      bar_max_speed=0;
   }
   if(prev_price==0.0)
   {
      prev_price=Close[0];//MarketInfo(Symbol(),MODE_BID);
      prev_speed=0;
      curr_speed=0;
   }
   else
   {
      prev_speed=curr_speed;
      //curr_speed=(MarketInfo(Symbol(),MODE_BID)-prev_price)/Point;
      //prev_price=MarketInfo(Symbol(),MODE_BID);
      curr_speed=(Close[0]-prev_price)/Point;
      prev_price=Close[0];

   } 
   Comment("Speed = ",curr_speed);
   if(curr_speed>1000 || curr_speed<-1000) curr_speed=0;
/*   if(MathAbs(curr_speed)>MathAbs(bar_max_speed))
   { 
      bar_max_speed=curr_speed;
      ExtMaxBuffer[0]=bar_max_speed/10;
   }
   */
   if(curr_speed>speed_max) 
   {     
         up_signals=up_signals+(curr_speed/speed_max);
         ExtBullsBuffer[0]=up_signals;
         if(up_signals>alert_on_count-1)
         {
            if (!show_alerts && play_sounds) PlaySound("alert.wav");
            if(show_alerts) Alert(Symbol()," Bull Count of ",up_signals, " on ",Symbol()); 
         }

   }
   if(curr_speed<-1*speed_max) 
   { 
         down_signals=down_signals+MathAbs(curr_speed/speed_max);
         ExtBearsBuffer[0]=-1*down_signals;

         if(down_signals>alert_on_count-1)
         {
            if (!show_alerts && play_sounds) PlaySound("alert2.wav");
            if(show_alerts) Alert(Symbol()," Bear Count of ",down_signals, " on ",Symbol());        
         }
   }

}