//+------------------------------------------------------------------+
//|                                                  MTF BB Fibo.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DimGray
#property indicator_color2 C'0,128,0'
#property indicator_color3 C'128,0,0'
#property indicator_color4 C'0,192,0'
#property indicator_color5 C'192,0,0'
#property indicator_color6 C'0,255,0'
#property indicator_color7 C'255,0,0'

/*---- input parameters
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame value with the indicator inputs.
---------------------------------------*/
//---- indicator parameters
//
//
//
//

extern int    TimeFrame  = 0;
extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BandsFiboDeviation1=1.618;
extern double BandsFiboDeviation2=2.618;
extern double BandsFiboDeviation3=3.618;

//---- buffers
//
//
//
//

double MovingBuffer[];
double UpperBuffer1[];
double LowerBuffer1[];
double UpperBuffer2[];
double LowerBuffer2[];
double UpperBuffer3[];
double LowerBuffer3[];



double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0,MovingBuffer);
   SetIndexBuffer(1,UpperBuffer1);
   SetIndexBuffer(2,LowerBuffer1);
   SetIndexBuffer(3,UpperBuffer2);
   SetIndexBuffer(4,LowerBuffer2);
   SetIndexBuffer(5,UpperBuffer3);
   SetIndexBuffer(6,LowerBuffer3);
   return(0);
  }
//----
 
//+------------------------------------------------------------------+
//| MTF BBFibo                                                       |
//+------------------------------------------------------------------+
int start()
{
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
    
   //
   //
   //
   //
   //

      if ((TimeFrame<Period()) && (TimeFrame>0))
         {
            Comment("MTF BBFibo removed from chart");
            return(-1);
         }            
      ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
      limit = MathMax(Bars - counted_bars,MathMax(TimeFrame/Period(),1));   

   //
   //
   //
   //
   //
   
   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y]) y++; 
         MovingBuffer[i]=iCustom(Symbol(),TimeFrame,"BBFibo",BandsPeriod,BandsShift,BandsFiboDeviation1,BandsFiboDeviation2,BandsFiboDeviation3,0,y);
         UpperBuffer1[i]=iCustom(Symbol(),TimeFrame,"BBFibo",BandsPeriod,BandsShift,BandsFiboDeviation1,BandsFiboDeviation2,BandsFiboDeviation3,1,y);
         LowerBuffer1[i]=iCustom(Symbol(),TimeFrame,"BBFibo",BandsPeriod,BandsShift,BandsFiboDeviation1,BandsFiboDeviation2,BandsFiboDeviation3,2,y);
         UpperBuffer2[i]=iCustom(Symbol(),TimeFrame,"BBFibo",BandsPeriod,BandsShift,BandsFiboDeviation1,BandsFiboDeviation2,BandsFiboDeviation3,3,y);
         LowerBuffer2[i]=iCustom(Symbol(),TimeFrame,"BBFibo",BandsPeriod,BandsShift,BandsFiboDeviation1,BandsFiboDeviation2,BandsFiboDeviation3,4,y);
         UpperBuffer3[i]=iCustom(Symbol(),TimeFrame,"BBFibo",BandsPeriod,BandsShift,BandsFiboDeviation1,BandsFiboDeviation2,BandsFiboDeviation3,5,y);
         LowerBuffer3[i]=iCustom(Symbol(),TimeFrame,"BBFibo",BandsPeriod,BandsShift,BandsFiboDeviation1,BandsFiboDeviation2,BandsFiboDeviation3,6,y);
   }
   return(0);
  }
//+------------------------------------------------------------------+