//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DimGray
#property indicator_color2 C'0,128,0'
#property indicator_color3 C'128,0,0'
#property indicator_color4 C'0,192,0'
#property indicator_color5 C'192,0,0'
#property indicator_color6 C'0,255,0'
#property indicator_color7 C'255,0,0'
//---- indicator parameters
extern int    BandsPeriod=20;
extern int    BandsMAMethod  = MODE_EMA; //"SMA0,EMA1,SMMA2,LWMA3;//price Close
extern int    BandsShift=0;
extern double BandsFiboDeviation1=1.618;
extern double BandsFiboDeviation2=2.618;
extern double BandsFiboDeviation3=3.618;
//---- buffers
double MovingBuffer[];
double UpperBuffer1[];
double LowerBuffer1[];
double UpperBuffer2[];
double LowerBuffer2[];
double UpperBuffer3[];
double LowerBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,MovingBuffer);
   SetIndexBuffer(1,UpperBuffer1);
   SetIndexBuffer(2,LowerBuffer1);
   SetIndexBuffer(3,UpperBuffer2);
   SetIndexBuffer(4,LowerBuffer2);
   SetIndexBuffer(5,UpperBuffer3);
   SetIndexBuffer(6,LowerBuffer3);
//----
   for (int i=0; i<indicator_buffers; i++) SetIndexDrawBegin(i,BandsPeriod+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer1[Bars-i]=EMPTY_VALUE;
         LowerBuffer1[Bars-i]=EMPTY_VALUE;
         UpperBuffer2[Bars-i]=EMPTY_VALUE;
         LowerBuffer2[Bars-i]=EMPTY_VALUE;
         UpperBuffer3[Bars-i]=EMPTY_VALUE;
         LowerBuffer3[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,BandsMAMethod,PRICE_CLOSE,i);
//----
   i=Bars-BandsPeriod+1;
   if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+BandsPeriod-1;
      oldval=MovingBuffer[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }
      deviation=BandsFiboDeviation1*MathSqrt(sum/BandsPeriod);
      UpperBuffer1[i]=oldval+deviation;
      LowerBuffer1[i]=oldval-deviation;
      deviation=BandsFiboDeviation2*MathSqrt(sum/BandsPeriod);
      UpperBuffer2[i]=oldval+deviation;
      LowerBuffer2[i]=oldval-deviation;
      deviation=BandsFiboDeviation3*MathSqrt(sum/BandsPeriod);
      UpperBuffer3[i]=oldval+deviation;
      LowerBuffer3[i]=oldval-deviation;
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+