//+------------------------------------------------------------------+
//|                                                 Order Alerts.mq4 |
//|                                                        Liquid007 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Liquid007"
#property link      ""

#property indicator_chart_window

int   oldnumber;

bool  firsttime = true;

extern bool EmailAlert = true,
            SoundAlert = true,
            PopupAlert = true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   if (AccountNumber() == 0)
      return(0);
   
   int i, total, number;
   total = OrdersTotal();
   
   for (i = 0; i < total; i++)
      {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if ((OrderType() == OP_BUY) || (OrderType() == OP_SELL))
         number++;
      }
      
   if(firsttime)
      {
      firsttime = false;
      oldnumber = number;
      }
   
   if(number != oldnumber)
      {      
      
         {
         if (number > oldnumber)
            {
            if (PopupAlert) Alert("Order " +OrderType() +" " +OrderSymbol() +" " +OrderTicket() +" " +DoubleToStr(OrderLots(),2)+"Lots", "" );    ////////
            if (SoundAlert) PlaySound("open.wav");
            if (EmailAlert) SendMail("Order " +OrderType() +" " +OrderSymbol() +" " +OrderTicket() +" " +DoubleToStr(OrderLots(),2)+"Lots", "" );    ////////

            }
         if (number < oldnumber)
            {
            total = OrdersHistoryTotal();
            OrderSelect(total -1,SELECT_BY_POS,MODE_HISTORY);
            if(OrderProfit() < 0)
               {
               if (PopupAlert) Alert("LOSS "+DoubleToStr(OrderProfit(),2) +" (" +DoubleToStr(OrderCommission(),2)+") " +OrderType() +" " +OrderSymbol() +" "+OrderTicket() +" " +DoubleToStr(OrderLots(),2)+"Lots", "" );    ////////
               if (SoundAlert) PlaySound("lose.wav");
               if (EmailAlert) SendMail("LOSS "+DoubleToStr(OrderProfit(),2) +" (" +DoubleToStr(OrderCommission(),2)+") " +OrderType() +" " +OrderSymbol() +" "+OrderTicket() +" " +DoubleToStr(OrderLots(),2)+"Lots", "" );    ////////
               }
            if(OrderProfit() >= 0.0)
               {
               if (PopupAlert) Alert("PROFIT "+DoubleToStr(OrderProfit(),2) +" (" +DoubleToStr(OrderCommission(),2)+") " +OrderType() +" " +OrderSymbol() +" "+OrderTicket() +" " +DoubleToStr(OrderLots(),2)+"Lots", "" );    ////////
               if (SoundAlert) PlaySound("win.wav");
               if (EmailAlert) SendMail("PROFIT "+DoubleToStr(OrderProfit(),2) +" (" +DoubleToStr(OrderCommission(),2)+") " +OrderType() +" " +OrderSymbol() +" "+OrderTicket() +" " +DoubleToStr(OrderLots(),2)+"Lots", "" );    ////////
               }

            }
         }
      oldnumber = number;        
      }
      
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+