//+------------------------------------------------------------------+
//|                                                    PlaceFibs.mq4 |
//|                                                    Steve Fleming |
//|                                         http://www.forexarea.com |
//+------------------------------------------------------------------+
#property copyright "Steve Fleming"
#property link      "http://www.forexarea.com"

//+------------------------------------------------------------------+
//| Script to place 3 sets of fibs as per Bobokus method found       |
//| at http://www.forexfactory.com/showthread.php?t=50767            |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----

	if(ObjectFind("DailyFib") == -1){
		ObjectCreate("DailyFib",OBJ_FIBO,0,Time[80],iLow(NULL, 0, 80),Time[80],iHigh(NULL, 0, 80));
      ObjectSet("DailyFib",OBJPROP_LEVELCOLOR,Tomato);
      ObjectSet("DailyFib",OBJPROP_FIBOLEVELS,11);
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("DailyFib",0,"Daily Low -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+0,1.000);	ObjectSetFiboDescription("DailyFib",1,"Daily High -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+2,0.809);	ObjectSetFiboDescription("DailyFib",2,"Daily S1 -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+3,0.618);	ObjectSetFiboDescription("DailyFib",3,"Daily Short -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+4,0.500);	ObjectSetFiboDescription("DailyFib",4,"Daily Pivot -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+5,0.382);	ObjectSetFiboDescription("DailyFib",5,"Daily Long -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+6,0.191);	ObjectSetFiboDescription("DailyFib",6,"Daily R1 -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+7,1.34);	ObjectSetFiboDescription("DailyFib",7,"Daily Target 1 -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+8,1.55);	ObjectSetFiboDescription("DailyFib",8,"Daily Target 2 -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+9,-0.34);	ObjectSetFiboDescription("DailyFib",9,"Daily Target 1 -  %$"); 
      ObjectSet("DailyFib",OBJPROP_FIRSTLEVEL+10,-0.55);	ObjectSetFiboDescription("DailyFib",10,"Daily Target 2 -  %$"); 
      ObjectSet("DailyFib",OBJPROP_RAY,true);
      ObjectSet("DailyFib",OBJPROP_BACK,true);
   }
   

   
   
	if(ObjectFind("IntermediateFib") == -1){
		ObjectCreate("IntermediateFib",OBJ_FIBO,0,Time[60],iLow(NULL, 0, 60),Time[60],iHigh(NULL, 0, 60));
      ObjectSet("IntermediateFib",OBJPROP_LEVELCOLOR,Gold);
      ObjectSet("IntermediateFib",OBJPROP_FIBOLEVELS,11);
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("IntermediateFib",0,"Intermediate Low -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+0,1.000);	ObjectSetFiboDescription("IntermediateFib",1,"Intermediate High -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+2,0.809);	ObjectSetFiboDescription("IntermediateFib",2,"Intermediate S1 -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+3,0.618);	ObjectSetFiboDescription("IntermediateFib",3,"Intermediate Short -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+4,0.500);	ObjectSetFiboDescription("IntermediateFib",4,"Intermediate Pivot -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+5,0.382);	ObjectSetFiboDescription("IntermediateFib",5,"Intermediate Long -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+6,0.191);	ObjectSetFiboDescription("IntermediateFib",6,"Intermediate R1 -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+7,1.34);	ObjectSetFiboDescription("IntermediateFib",7,"Intermediate Target 1 -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+8,1.55);	ObjectSetFiboDescription("IntermediateFib",8,"Intermediate Target 2 -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+9,-0.34);	ObjectSetFiboDescription("IntermediateFib",9,"Intermediate Target 1 -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_FIRSTLEVEL+10,-0.55);	ObjectSetFiboDescription("IntermediateFib",10,"Intermediate Target 2 -  %$"); 
      ObjectSet("IntermediateFib",OBJPROP_RAY,true);
      ObjectSet("IntermediateFib",OBJPROP_BACK,true);
   }
   

   
   if(ObjectFind("RangeFib") == -1){
		ObjectCreate("RangeFib",OBJ_FIBO,0,Time[40],iLow(NULL, 0, 40),Time[40],iHigh(NULL, 0, 40));
	   ObjectSet("RangeFib",OBJPROP_LEVELCOLOR,Violet);
      ObjectSet("RangeFib",OBJPROP_FIBOLEVELS,11);
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("RangeFib",0,"Range Low -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+0,1.000);	ObjectSetFiboDescription("RangeFib",1,"Range High -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+2,0.809);	ObjectSetFiboDescription("RangeFib",2,"Range S1 -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+3,0.618);	ObjectSetFiboDescription("RangeFib",3,"Range Short -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+4,0.500);	ObjectSetFiboDescription("RangeFib",4,"Range Pivot -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+5,0.382);	ObjectSetFiboDescription("RangeFib",5,"Range Long -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+6,0.191);	ObjectSetFiboDescription("RangeFib",6,"Range R1 -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+7,1.34);	ObjectSetFiboDescription("RangeFib",7,"Range Target 1 -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+8,1.55);	ObjectSetFiboDescription("RangeFib",8,"Range Target 2 -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+9,-0.34);	ObjectSetFiboDescription("RangeFib",9,"Range Target 1 -  %$"); 
      ObjectSet("RangeFib",OBJPROP_FIRSTLEVEL+10,-0.55);	ObjectSetFiboDescription("RangeFib",10,"Range Target 2 -  %$"); 
      ObjectSet("RangeFib",OBJPROP_RAY,true);
      ObjectSet("RangeFib",OBJPROP_BACK,true);
   }
   
   if(ObjectFind("IntraDayFib") == -1){
		ObjectCreate("IntraDayFib",OBJ_FIBO,0,Time[20],iLow(NULL, 0, 20),Time[10],iHigh(NULL, 0, 20));
	   ObjectSet("IntraDayFib",OBJPROP_LEVELCOLOR,DodgerBlue);
      ObjectSet("IntraDayFib",OBJPROP_FIBOLEVELS,11);
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("IntraDayFib",0,"IntraDay Low -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+0,1.000);	ObjectSetFiboDescription("IntraDayFib",1,"IntraDay High -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+2,0.809);	ObjectSetFiboDescription("IntraDayFib",2,"IntraDay S1 -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+3,0.618);	ObjectSetFiboDescription("IntraDayFib",3,"IntraDay Short -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+4,0.500);	ObjectSetFiboDescription("IntraDayFib",4,"IntraDay Pivot -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+5,0.382);	ObjectSetFiboDescription("IntraDayFib",5,"IntraDay Long -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+6,0.191);	ObjectSetFiboDescription("IntraDayFib",6,"IntraDay R1 -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+7,1.34);	ObjectSetFiboDescription("IntraDayFib",7,"IntraDay Target 1 -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+8,1.55);	ObjectSetFiboDescription("IntraDayFib",8,"IntraDay Target 2 -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+9,-0.34);	ObjectSetFiboDescription("IntraDayFib",9,"IntraDay Target 1 -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_FIRSTLEVEL+10,-0.55);	ObjectSetFiboDescription("IntraDayFib",10,"IntraDay Target 2 -  %$"); 
      ObjectSet("IntraDayFib",OBJPROP_RAY,true);
      ObjectSet("IntraDayFib",OBJPROP_BACK,true);
   }

   if(ObjectFind("SwingFib") == -1){
		ObjectCreate("SwingFib",OBJ_FIBO,0,Time[0],iLow(NULL, 0, 0),Time[0],iHigh(NULL, 0, 0));
	   ObjectSet("SwingFib",OBJPROP_LEVELCOLOR,Lime);
      ObjectSet("SwingFib",OBJPROP_FIBOLEVELS,11);
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("SwingFib",0,"Swing Low -  %$"); 
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+0,1.000);	ObjectSetFiboDescription("SwingFib",1,"Swing High -  %$"); 
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+3,0.618);	ObjectSetFiboDescription("SwingFib",3,"Swing Short -  %$"); 
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+4,0.500);	ObjectSetFiboDescription("SwingFib",4,"Swing Pivot -  %$"); 
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+5,0.382);	ObjectSetFiboDescription("SwingFib",5,"Swing Long -  %$"); 
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+7,1.34);	ObjectSetFiboDescription("SwingFib",7,"Swing Target 1 -  %$"); 
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+8,1.55);	ObjectSetFiboDescription("SwingFib",8,"Swing Target 2 -  %$"); 
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+9,-0.34);	ObjectSetFiboDescription("SwingFib",9,"Swing Target 1 -  %$"); 
      ObjectSet("SwingFib",OBJPROP_FIRSTLEVEL+10,-0.55);	ObjectSetFiboDescription("SwingFib",10,"Swing Target 2 -  %$"); 
      ObjectSet("SwingFib",OBJPROP_RAY,true);
      ObjectSet("SwingFib",OBJPROP_BACK,true);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+