//+------------------------------------------------------------------+
//|                                               Pozci_pts.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window


//--- input parameters
extern int kezd = 50;
extern int vg = 1;
double arH, arL, target, arH_target, arL_target;
datetime ido, idoKezd;




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   arH=High[iHighest(NULL,0,MODE_HIGH,kezd-vg,vg)];
   arL=Low[iLowest(NULL,0,MODE_LOW,kezd-vg,vg)];
   target=arH-arL;
   arH_target=arH+target;
   arL_target=arL-target;
   ido=iTime(Symbol(),0,1); 
   idoKezd = iTime(Symbol(),0,kezd);
   
   vizszintes_vonal_rajzolas("High", Blue, arH, ido);
   vizszintes_vonal_rajzolas("Low", Red, arL, ido);
   vizszintes_vonal_rajzolas("Target_High", Blue, arH, ido);
   vizszintes_vonal_rajzolas("Target_Low", Red, arH, ido);
   sav_rajzolas("Buy_band", Yellow, 0, 0, 0, 0);
   sav_rajzolas("Sell_band", Yellow, 0, 0, 0, 0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("High");
   ObjectDelete("Low");
   ObjectDelete("Target_High");
   ObjectDelete("Target_Low");
   ObjectDelete("Buy_band");
   ObjectDelete("Sell_band");
//----
   return(0);
  }
  
void sav_rajzolas(string nev, int szin, datetime idoSavKezd, double arSavKezd, datetime idoSavVeg, double arSavVeg)
   {   
   ObjectCreate (nev, OBJ_RECTANGLE, 0, idoSavKezd, arSavKezd, idoSavVeg, arSavVeg);
   ObjectSet(nev, OBJPROP_COLOR, Yellow);
   }
   
void sav_modositas(string nev, datetime idoSavKezd, double arSavKezd, datetime idoSavVeg, double arSavVeg)
   {
   ObjectMove(nev, 0, idoSavKezd, arSavKezd);
   ObjectMove(nev, 1, idoSavVeg, arSavVeg);
   }
  
void vizszintes_vonal_rajzolas(string nev, int szin, double ar, datetime ido)
   {   
   ObjectCreate (nev, OBJ_TREND, 0, idoKezd, ar, ido, ar);
   ObjectSet(nev, OBJPROP_RAY, false);
   ObjectSet(nev, OBJPROP_COLOR, szin);
   }
      
void vonal_modost(string nev, datetime ido, double ar)
   {
   ObjectMove(nev, 0, idoKezd, ar);
   ObjectMove(nev, 1, ido, ar);
   } 

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {

   ido=iTime(Symbol(),0,1);
  
   vonal_modost("High", ido, arH);
   vonal_modost("Low", ido, arL);

//   sav_rajzolas("band1", Yellow, ido, arL, idoKezd, arH);   
    
   if(Bid > arH_target){      
      sav_modositas("Buy_band", ido, Bid-target, idoKezd, arH);
      arH_target=Bid;

   }
   
   if(Bid < arL_target){
      sav_modositas("Sell_band", ido, Bid+target, idoKezd, arL);
      arL_target=Bid;

   }
   
   vonal_modost("Target_High", ido, arH_target);   
   vonal_modost("Target_Low", ido, arL_target);
   sav_modositas("Buy_band", ido, arH_target-target, idoKezd, arH);   
   sav_modositas("Sell_band", ido, arL_target+target, idoKezd, arL);

   return(0);
  }
//+------------------------------------------------------------------+