#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DarkBlue

//--- input parameters
int       iADXPeriod=14;
int       iAdxVonal = 40;
//--- buffers
double adxBuffer[];
double dmPlus[];
double dmMinus[];
double sumDmPlus[];
double sumDmMinus[];
double sumTr[];
double tr[];

//--------vltoz
double adxP = 0.00;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(7);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,adxBuffer);
   
   SetIndexBuffer(1,dmPlus);
   SetIndexBuffer(2,dmMinus);
   SetIndexBuffer(3,sumDmPlus);
   SetIndexBuffer(4,sumDmMinus);
   SetIndexBuffer(5,sumTr);
   SetIndexBuffer(6,tr);
   

//----
   IndicatorShortName("AdxSeged("+iADXPeriod+", "+iAdxVonal+")");
   SetIndexLabel(0,"AdxSeged");
  
  SetLevelStyle(STYLE_SOLID,2,Red);
  SetLevelValue(0, iAdxVonal);
   //az elz indts?
   switch(UninitializeReason())
   {
    case REASON_CHARTCLOSE:     Print("chart bezrs");        // chart bezrs
    case REASON_REMOVE:     Print("levtel, vltozs");   break; // trls s pucols
    case REASON_RECOMPILE:
    case REASON_CHARTCHANGE:     Print("Chart vltozs"); break;      // chart vltozs
    case REASON_PARAMETERS:    Print("Paramter vltozs"); break;      // msik paramter
    case REASON_ACCOUNT:      break;  // j szmla
   }
   
   
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   adxP = iADXPeriod;
   int counted_bars=IndicatorCounted();
   int i = Bars-counted_bars-1;
//----

   
      
   while (i>=0){

     tr[i]= MathMax(Low[i]-Close[i+1], MathMax(High[i]-Low[i],MathAbs(High[i]-Close[i+1])));
     if(High[i]-High[i+1] > Low[i+1]-Low[i]){
         dmPlus[i]= MathMax(High[i]-High[i+1],0);
     }
     else{
         dmPlus[i]= 0;
     }
     if(Low[i+1]-Low[i]>High[i]-High[i+1]){
         dmMinus[i] = MathMax(Low[i+1]-Low[i],0);
     }
     else{
         dmMinus[i] = 0;
     }
     
     
     sumTr[i] = sumTr[i+1]-sumTr[i+1]/adxP + tr[i];
     sumDmPlus[i] = sumDmPlus[i+1]-sumDmPlus[i+1]/adxP + dmPlus[i];
     sumDmMinus[i] = sumDmMinus[i+1]-sumDmMinus[i+1]/adxP + dmMinus[i];
     
     
     double diPlus = 0;
     double diMinus = 0;
     
     if(sumTr[i] > 0.00){
         diPlus = 100* (sumDmPlus[i] / sumTr[i]);
         diMinus = 100* (sumDmMinus[i] / sumTr[i]);
     }
     double diff = MathAbs(diPlus-diMinus);
     double sum = diPlus+diMinus;
     
     if(sum == 0){
      adxBuffer[i] = 50;
      }
      else{
         adxBuffer[i] = ((adxP-1)*adxBuffer[i+1]+100*diff/sum)/adxP;
      }
     i--;
   }
 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+



