//+------------------------------------------------------------------+
//| #PH#StochCrossOver.mq4                                           |
//+------------------------------------------------------------------+
//| Forex Factory --> Forums --> Trading Systems -->                 |
//| one tool timeframe trading      Author system: TEB63             |
//+------------------------------------------------------------------+
//| Code by fewhills with help from other code                       |
//| changes [2] before bar close and cross over: other colors        |
//|             starts with first bar instead of second              |  
//| changes [3] MAJOR change in the Alert part of the code           |
//|             added AlertNrOfTFs = at least how m//any the same    |
//|             colors together give the alert                       |  
//| changes [4] Stoch Parameters per period                          |
//| changes [5] Symbols added in alert                               |
//+------------------------------------------------------------------+

      

#property indicator_chart_window

#define PH_OP_NONE -1
#define PH_OP_BUY   1
#define PH_OP_SELL  2

//------- -------------------------------
extern int    period1               =    15;      // Must always have a positive number in minutes
extern int    period2               =    30;      // if MaxNumberOfLinesP2 > 0 then this must always have a positive number in minutes
extern int    period3               =   60;      // if MaxNumberOfLinesP3 > 0 then this must always have a positive number in minutes
extern int    period4               =   240;      // if MaxNumberOfLinesP4 > 0 then this must always have a positive number in minutes
extern int    MaxNumberOfBars       =   30;      // Show the lines within how many period1 bars
extern int    MaxNumberOfLinesP1    =    1;      // How many period1 vertical lines will be shown - show this one always 
extern int    MaxNumberOfLinesP2    =    1;      // How many period2 vertical lines will be shown - 0 means don't show this period
extern int    MaxNumberOfLinesP3    =    1;      // How many period3 vertical lines will be shown - 1 means just show one line of this period
extern int    MaxNumberOfLinesP4    =    1;      // How many period4 vertical lines will be shown - 1 or more = # of lines per period
extern int    ShiftLine             =    0;      // Move line per # of bars back or forward  (negative = forward)
extern int    KPeriod1              =    5;      // Stochastic KPeriod
extern int    DPeriod1              =    3;      // Stochastic DPeriod
extern int    Slowing1              =    3;      // Stochastic Slowing
extern int    KPeriod2              =   5;      // Stochastic KPeriod
extern int    DPeriod2              =    3;      // Stochastic DPeriod
extern int    Slowing2              =    3;      // Stochastic Slowing
extern int    KPeriod3              =    5;      // Stochastic KPeriod
extern int    DPeriod3              =    3;      // Stochastic DPeriod
extern int    Slowing3              =    3;      // Stochastic Slowing
extern int    KPeriod4              =   5;      // Stochastic KPeriod
extern int    DPeriod4              =    3;      // Stochastic DPeriod
extern int    Slowing4              =    3;      // Stochastic Slowing
extern color  UpColor1              = Blue;      // Up line color 
extern color  DownColor1            = Red;       // Down line color
extern color  NoneCloseUpColor1     = Aqua;      // None closed bar color
extern color  NoneCloseDownColor1   = Gold;      // None closed bar color
extern color  UpColor2              = Blue;      // Up line color 
extern color  DownColor2            = Red;       // Down line color
extern color  NoneCloseUpColor2     = Aqua;      // None closed bar color
extern color  NoneCloseDownColor2   = Gold;      // None closed bar color
extern color  UpColor3              = Blue;      // Up line color 
extern color  DownColor3            = Red;       // Down line color
extern color  NoneCloseUpColor3     = Aqua;      // None closed bar color
extern color  NoneCloseDownColor3   = Gold;      // None closed bar color
extern color  UpColor4              = Blue;      // Up line color 
extern color  DownColor4            = Red;       // Down line color
extern color  NoneCloseUpColor4     = Aqua;      // None closed bar color
extern color  NoneCloseDownColor4   = Gold;      // None closed bar color
extern int    MAMode                = MODE_SMA;  // Stochastic MA method, default 0   0=SMA 1=EMA 2=SMMA 3=LWMA
extern int    PriceField            =    0;      // Stochastic Price method:   0 = H/L   1 = Close/Close   
extern int    AlertNrOfTFs          =    4;      // at least how many the same Colors with different TF's together give the Alert, 1 = as system was
extern bool   AlertOn               = true;      // general alert on or off (does not influence sendmail)
extern bool   AlertPeriod1          = true;      // need an alert if period1 is triggered?
extern bool   AlertPeriod2          = true;      // need an alert if period2 is triggered?
extern bool   AlertPeriod3          = true;      // need an alert if period3 is triggered?  
extern bool   AlertPeriod4          = true;      // need an alert if period4 is triggered?
extern bool   SendMailOn            = false;     // send alert if live account  
// define your own alert when there is a mixed cross over / continuation
extern string  Up_2Dn_3Up_4Up       = "";     // "Buy"  or "NoTrade" or empty string
extern string  Up_2Up_3Dn_4Up       = "";     // "Buy"  or "NoTrade"
extern string  Up_2Up_3Up_4Dn       = "";     // "Buy"  or "NoTrade"
extern string  Up_2Dn_3Up           = "";     // "Buy"  or "NoTrade"
extern string  Up_2Up_3Dn           = "";     // "Buy"  or "NoTrade"
extern string  Up_2Dn_4Up           = "";     // "Buy"  or "NoTrade"
extern string  Up_2Up_4Dn           = "";     // "Buy"  or "NoTrade"
extern string  Up_3Dn_4Up           = "";     // "Buy"  or "NoTrade"
extern string  Up_3Up_4Dn           = "";     // "Buy"  or "NoTrade"
extern string  Dn_2Up_3Dn_4Dn       = "";    // "Sell" or "NoTrade"
extern string  Dn_2Dn_3Up_4Dn       = "";    // "Sell" or "NoTrade"
extern string  Dn_2Dn_3Dn_4Up       = "";    // "Sell" or "NoTrade"
extern string  Dn_2Up_3Dn           = "";    // "Sell" or "NoTrade"
extern string  Dn_2Dn_3Up           = "";    // "Sell" or "NoTrade"
extern string  Dn_2Up_4Dn           = "";    // "Sell" or "NoTrade"
extern string  Dn_2Dn_4Up           = "";    // "Sell" or "NoTrade"
extern string  Dn_3Up_4Dn           = "";    // "Sell" or "NoTrade"
extern string  Dn_3Dn_4Up           = "";    // "Sell" or "NoTrade"


#define NEGATIVE_RESULT -1
//+------------------------------------------------------------------+
//| Make strings from periods                                        |
//+------------------------------------------------------------------+
string givePerStr(int period)
{
   string retPerStr = "";
   switch (period)
   {
      case PERIOD_M1  : retPerStr = retPerStr + " 15 Min"; break;
      case PERIOD_M5  : retPerStr = retPerStr + " 30 Min"; break;
      case PERIOD_M15 : retPerStr = retPerStr + " 1 Hour"; break;
      case PERIOD_M30 : retPerStr = retPerStr + " 4 Hour"; break;
      case PERIOD_H1  : retPerStr = retPerStr + " 1 Hour"; break;
      case PERIOD_H4  : retPerStr = retPerStr + " 4 Hour"; break;
      case PERIOD_D1  : retPerStr = retPerStr + " 1 Day"; break;
      case PERIOD_W1  : retPerStr = retPerStr + " 1 Week"; break;
      case PERIOD_MN1 : retPerStr = retPerStr + " 1 Month"; break;
      default:          retPerStr = "wrong period"; break;
   }
   return (retPerStr);           
}
string givePeriodStr(int period,int K,int D, int S)
{
   string retPerStr = "Stoch(";
   retPerStr = retPerStr + K;
   retPerStr = retPerStr + ",";
   retPerStr = retPerStr + D;
   retPerStr = retPerStr + ",";
   retPerStr = retPerStr + S;
   retPerStr = retPerStr + ") ";
   retPerStr = retPerStr + givePerStr(period) + " ";
   return (retPerStr);           
}

void init() 
{
  int i, period = Period();
  DeleteObjects();
  for (i=0; i<MaxNumberOfBars; i++) 
  {
     if (MaxNumberOfLinesP1>0 && period<=period1) CreateObjects(givePeriodStr(period1,KPeriod1,DPeriod1,Slowing1)+"["+i+"]", 1);
     if (MaxNumberOfLinesP2>0 && period<=period2) CreateObjects(givePeriodStr(period2,KPeriod2,DPeriod2,Slowing2)+"["+i+"]", 2);
     if (MaxNumberOfLinesP3>0 && period<=period3) CreateObjects(givePeriodStr(period3,KPeriod3,DPeriod3,Slowing3)+"["+i+"]", 3);
     if (MaxNumberOfLinesP4>0 && period<=period4) CreateObjects(givePeriodStr(period4,KPeriod4,DPeriod4,Slowing4)+"["+i+"]", 4);
  }
}

void deinit() 
{
  DeleteObjects();
}

void CreateObjects(string vL, int width) 
{
   ObjectCreate(vL,OBJ_VLINE,0,0,NULL);
   ObjectSet(vL,OBJPROP_WIDTH,width);
   ObjectSet(vL,OBJPROP_STYLE,STYLE_SOLID);  
}

void DeleteObjects() 
{
  int i, period = Period();
  for (i=0; i<MaxNumberOfBars; i++) 
  {
     if (MaxNumberOfLinesP1>0 && period<=period1) ObjectDelete(givePeriodStr(period1,KPeriod1,DPeriod1,Slowing1)+"["+i+"]");
     if (MaxNumberOfLinesP2>0 && period<=period2) ObjectDelete(givePeriodStr(period2,KPeriod2,DPeriod2,Slowing2)+"["+i+"]");
     if (MaxNumberOfLinesP3>0 && period<=period3) ObjectDelete(givePeriodStr(period3,KPeriod3,DPeriod3,Slowing3)+"["+i+"]");
     if (MaxNumberOfLinesP4>0 && period<=period4) ObjectDelete(givePeriodStr(period4,KPeriod4,DPeriod4,Slowing4)+"["+i+"]");
  }
}

//+------------------------------------------------------------------+
//| Has 2 functions                                                  |
//| 1) show cross overs                                              |
//| OR                                                               |
//| 2) show stoch direction including cross overs                    |
//+------------------------------------------------------------------+
int showStochasticRoute(int timeFrame,int i,bool giveTrend,int KPeriod,int DPeriod,int Slowing)
{
   int sSR = NEGATIVE_RESULT;
   
   double StochM1=iStochastic(NULL,timeFrame,KPeriod,DPeriod,Slowing,MAMode,PriceField,MODE_MAIN,i);
   double StochS1=iStochastic(NULL,timeFrame,KPeriod,DPeriod,Slowing,MAMode,PriceField,MODE_SIGNAL,i);
   double StochM2=iStochastic(NULL,timeFrame,KPeriod,DPeriod,Slowing,MAMode,PriceField,MODE_MAIN,i+1);
   double StochS2=iStochastic(NULL,timeFrame,KPeriod,DPeriod,Slowing,MAMode,PriceField,MODE_SIGNAL,i+1);
   
   if                              // MAIN CROSSING SIGNAL UP
      (   StochM1 > StochS1
       && StochM2 < StochS2) 
       sSR = PH_OP_BUY;
   
   else if                         // MAIN CROSSING SIGNAL DOWN
      (   StochM1 < StochS1
       && StochM2 > StochS2) 
       sSR = PH_OP_SELL;

   if (giveTrend)
   {
      if (
         (sSR==PH_OP_BUY)      ||     // CROSSING OR CONTINUATION 
         (StochM1 > StochM2 &&
          StochS1 > StochS2 &&
          StochM1 > StochS1 &&
          StochM2 > StochS2)) sSR=PH_OP_BUY;
      else if (
         (sSR==PH_OP_SELL)     ||
         (StochM1 < StochM2 &&
          StochS1 < StochS2 &&
          StochM1 < StochS1 &&
          StochM2 < StochS2)) sSR=PH_OP_SELL;
   }
   return (sSR);
}

datetime CheckTimePeriod1Alert;
datetime CheckTimePeriod2Alert;
datetime CheckTimePeriod3Alert;
datetime CheckTimePeriod4Alert;

#define MAX_PH_PS 4

bool AlertP1;   
bool AlertP2;   
bool AlertP3;   
bool AlertP4;   

void start() 
{
   int sSR      = 0;
   color colr;
   string trend   = Symbol()+", Stochastic cross over period: ";
   int period = Period();
   int  i;
   int maxP1=0;
   int maxP2=0;
   int maxP3=0;
   int maxP4=0;
   int ups=0;
   int downs=0;
   int p1[MAX_PH_PS];
   int p2[MAX_PH_PS];
   int p3[MAX_PH_PS];
   int p4[MAX_PH_PS];

   if      (MaxNumberOfLinesP1<1) { Alert("First period must have a positive number."); return(0); }
   else if (MaxNumberOfLinesP1<1 && MaxNumberOfLinesP2<1 && MaxNumberOfLinesP3<1 && MaxNumberOfLinesP4<1) 
         { Alert("Period settings wrong."); return(0); }

   DeleteObjects();

   bool AlertDone = false;

   for (i=0;i<MAX_PH_PS;i++)
   {
     p1[i] = PH_OP_NONE;
     p2[i] = PH_OP_NONE;
     p3[i] = PH_OP_NONE;
     p4[i] = PH_OP_NONE;
   }   

   AlertP1 = false;
   AlertP2 = false;
   AlertP3 = false;
   AlertP4 = false;

   for (i=0; i<MaxNumberOfBars; i++) 
   {
      if (maxP1 < MaxNumberOfLinesP1 && period <= period1)
      {    
         CreateObjects(givePeriodStr(period1,KPeriod1,DPeriod1,Slowing1)+"["+i+"]", 1);
         sSR = showStochasticRoute(period1,i,false,KPeriod1,DPeriod1,Slowing1);
         if (sSR!=NEGATIVE_RESULT) 
         {
            if (maxP1 < 1 && 0==iBarShift(NULL,period1,iTime(NULL,period1,i),true))
            {
               if      (sSR==PH_OP_BUY)  { colr = NoneCloseUpColor1;      }
               else if (sSR==PH_OP_SELL) { colr = NoneCloseDownColor1;    }
            }
            else
            {
               if      (sSR==PH_OP_BUY)  { colr = UpColor1;   }
              else if (sSR==PH_OP_SELL) { colr = DownColor1; }
            }   
            if (maxP1 < 1 && CheckTimePeriod1Alert!=iTime(NULL,period1,0))  // only most recent
            {
               if      (sSR==PH_OP_BUY)  { colr = UpColor1;   }
               else if (sSR==PH_OP_SELL) { colr = DownColor1; }
               CheckTimePeriod1Alert = iTime(NULL,period1,0);
               if (AlertPeriod1) AlertP1 = true;  //Alert("30min i="+i);
            }
 //           ObjectSet(givePeriodStr(period1,KPeriod1,DPeriod1,Slowing1)+"["+i+"]",OBJPROP_COLOR,colr);
 //           ObjectSet(givePeriodStr(period1,KPeriod1,DPeriod1,Slowing1)+"["+i+"]",OBJPROP_TIME1,iTime(NULL,period1,i+ShiftLine));
            if (maxP1 < MAX_PH_PS) p1[maxP1] = sSR;
            maxP1++;
         }   
      }
      if (maxP2 < MaxNumberOfLinesP2 && period <= period2)
      {    
         CreateObjects(givePeriodStr(period2,KPeriod2,DPeriod2,Slowing2)+"["+i+"]", 2);
         sSR = showStochasticRoute(period2,i,false,KPeriod2,DPeriod2,Slowing2);
         if (sSR!=NEGATIVE_RESULT) 
         {
            if (maxP2 < 1 && 0==iBarShift(NULL,period2,iTime(NULL,period2,i),true))
            {
               if      (sSR==PH_OP_BUY)  { colr = NoneCloseUpColor2;      }
               else if (sSR==PH_OP_SELL) { colr = NoneCloseDownColor2;    }
            }   
            else
            {
              if      (sSR==PH_OP_BUY)  { colr = UpColor2;   }
               else if (sSR==PH_OP_SELL) { colr = DownColor2; }
            }   
            if (maxP2 < 1 && CheckTimePeriod2Alert!=iTime(NULL,period2,0))  // only most recent
            {
              if      (sSR==PH_OP_BUY)  { colr = UpColor2;   }
               else if (sSR==PH_OP_SELL) { colr = DownColor2; }
               CheckTimePeriod2Alert = iTime(NULL,period2,0);
               if (AlertPeriod2) AlertP2 = true; //Alert("1hr i="+i);
            }
 //           ObjectSet(givePeriodStr(period2,KPeriod2,DPeriod2,Slowing2)+"["+i+"]",OBJPROP_COLOR,colr);
 //           ObjectSet(givePeriodStr(period2,KPeriod2,DPeriod2,Slowing2)+"["+i+"]",OBJPROP_TIME1,iTime(NULL,period2,i+ShiftLine));
            if (maxP2 < MAX_PH_PS) p2[maxP2] = sSR;
            maxP2++;
         }   
      }
      if (maxP3 < MaxNumberOfLinesP3 && period <= period3)
      {    
         CreateObjects(givePeriodStr(period3,KPeriod3,DPeriod3,Slowing3)+"["+i+"]", 3);
         sSR = showStochasticRoute(period3,i,false,KPeriod3,DPeriod3,Slowing3);
         if (sSR!=NEGATIVE_RESULT) 
         {
            if (maxP3 < 1 && 0==iBarShift(NULL,period3,iTime(NULL,period3,i),true))
            {          
               if      (sSR==PH_OP_BUY)  { colr = NoneCloseUpColor3;      }
               else if (sSR==PH_OP_SELL) { colr = NoneCloseDownColor3;    }
            }   
            else
            {
               if      (sSR==PH_OP_BUY)  { colr = UpColor3;   }
               else if (sSR==PH_OP_SELL) { colr = DownColor3; }
            }   
            if (maxP3 < 1 && CheckTimePeriod3Alert!=iTime(NULL,period3,0))  // only most recent
            {
               if      (sSR==PH_OP_BUY)  { colr = UpColor3;   }
               else if (sSR==PH_OP_SELL) { colr = DownColor3; }
               CheckTimePeriod3Alert = iTime(NULL,period3,0);
               if (AlertPeriod3) AlertP3 = true; 
            }
//            ObjectSet(givePeriodStr(period3,KPeriod3,DPeriod3,Slowing3)+"["+i+"]",OBJPROP_COLOR,colr);
//            ObjectSet(givePeriodStr(period3,KPeriod3,DPeriod3,Slowing3)+"["+i+"]",OBJPROP_TIME1,iTime(NULL,period3,i+ShiftLine));
            if (maxP3 < MAX_PH_PS) p3[maxP3] = sSR;
            maxP3++;
         }   
      }
      if (maxP4 < MaxNumberOfLinesP4 && period <= period4)
      {    
         CreateObjects(givePeriodStr(period4,KPeriod4,DPeriod4,Slowing4)+"["+i+"]", 4);
         sSR = showStochasticRoute(period4,i,false,KPeriod4,DPeriod4,Slowing4);
         if (sSR!=NEGATIVE_RESULT) 
         {
            if (maxP4 < 1 && 0==iBarShift(NULL,period4,iTime(NULL,period4,i),true))
            {          
               if      (sSR==PH_OP_BUY)  { colr = NoneCloseUpColor4;      }
               else if (sSR==PH_OP_SELL) { colr = NoneCloseDownColor4;    }
            }   
            else
            {
               if      (sSR==PH_OP_BUY)  { colr = UpColor4;   }
               else if (sSR==PH_OP_SELL) { colr = DownColor4; }
            }   
            if (maxP4 < 1 && CheckTimePeriod4Alert!=iTime(NULL,period4,0))  // only most recent
            {
               if      (sSR==PH_OP_BUY)  { colr = UpColor4;   }
               else if (sSR==PH_OP_SELL) { colr = DownColor4; }
               CheckTimePeriod4Alert = iTime(NULL,period4,0);
               if (AlertPeriod4) AlertP4 = true;
            }
 //           ObjectSet(givePeriodStr(period4,KPeriod4,DPeriod4,Slowing4)+"["+i+"]",OBJPROP_COLOR,colr);
 //           ObjectSet(givePeriodStr(period4,KPeriod4,DPeriod4,Slowing4)+"["+i+"]",OBJPROP_TIME1,iTime(NULL,period4,i+ShiftLine));
            if (maxP4 < MAX_PH_PS) p4[maxP4] = sSR;
            maxP4++;
         }   
      }
   }   

      if ( !AlertDone &&
           (AlertP1 || 
            AlertP2 ||
            AlertP3 ||
            AlertP4)   )
      {
         for (int g=0;g<MAX_PH_PS;g++)  // determine the sets of TF's and trends/cross over to give an Alert 
         {
            if (AlertNrOfTFs==4)
            { 
               // buy alerts
               if (p1[g]==PH_OP_BUY && p2[g]==PH_OP_BUY && p3[g]==PH_OP_BUY && p4[g]==PH_OP_BUY) 
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_BUY, PH_OP_BUY, PH_OP_BUY);
               }
               else if (Up_2Dn_3Up_4Up == "Buy" && p1[g]==PH_OP_BUY && p2[g]==PH_OP_SELL && p3[g]==PH_OP_BUY && p4[g]==PH_OP_BUY) 
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_SELL, PH_OP_BUY, PH_OP_BUY);
               }
               else if (Up_2Up_3Dn_4Up == "Buy" && p1[g]==PH_OP_BUY && p2[g]==PH_OP_BUY && p3[g]==PH_OP_SELL && p4[g]==PH_OP_BUY) 
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_BUY, PH_OP_SELL, PH_OP_BUY);
               }
               else if (Up_2Up_3Up_4Dn == "Buy" && p1[g]==PH_OP_BUY && p2[g]==PH_OP_BUY && p3[g]==PH_OP_BUY && p4[g]==PH_OP_SELL) 
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_BUY, PH_OP_BUY, PH_OP_SELL);
               }
               // sell alerts
               if (p1[g]==PH_OP_SELL && p2[g]==PH_OP_SELL && p3[g]==PH_OP_SELL && p4[g]==PH_OP_SELL) 
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_SELL, PH_OP_SELL, PH_OP_SELL);
               }
               else if (Dn_2Up_3Dn_4Dn == "Sell" && p1[g]==PH_OP_SELL && p2[g]==PH_OP_BUY && p3[g]==PH_OP_SELL && p4[g]==PH_OP_SELL) 
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_BUY, PH_OP_SELL, PH_OP_SELL);
               }
               else if (Dn_2Dn_3Up_4Dn == "Sell" && p1[g]==PH_OP_SELL && p2[g]==PH_OP_SELL && p3[g]==PH_OP_BUY && p4[g]==PH_OP_SELL) 
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_SELL, PH_OP_BUY, PH_OP_SELL);
               }
               else if (Dn_2Dn_3Dn_4Up == "Sell" && p1[g]==PH_OP_SELL && p2[g]==PH_OP_SELL && p3[g]==PH_OP_SELL && p4[g]==PH_OP_BUY) 
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_SELL, PH_OP_SELL, PH_OP_BUY);
               }

            }     
            else if (AlertNrOfTFs==3)
            {
               // buy alerts
               if (p1[g]==PH_OP_BUY && p2[g]==PH_OP_BUY && p3[g]==PH_OP_BUY)
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_BUY, PH_OP_BUY, PH_OP_NONE);
               }
               else if (p1[g]==PH_OP_BUY && p2[g]==PH_OP_BUY && p4[g]==PH_OP_BUY)
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_BUY, PH_OP_NONE, PH_OP_BUY);
               }
               else if (p1[g]==PH_OP_BUY && p3[g]==PH_OP_BUY && p4[g]==PH_OP_BUY)
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_NONE, PH_OP_BUY, PH_OP_BUY);
               }
               else if (Up_2Dn_3Up=="Buy" && p1[g]==PH_OP_BUY && p2[g]==PH_OP_SELL && p3[g]==PH_OP_BUY ) 
               { 
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_SELL, PH_OP_BUY, PH_OP_NONE);
               }
               else if (Up_2Up_3Dn=="Buy" && p1[g]==PH_OP_BUY && p2[g]==PH_OP_BUY && p3[g]==PH_OP_SELL ) 
               { 
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_BUY, PH_OP_SELL, PH_OP_NONE);
               }
               else if (Up_2Dn_4Up=="Buy" && p1[g]==PH_OP_BUY && p2[g]==PH_OP_SELL && p4[g]==PH_OP_BUY ) 
               { 
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_SELL, PH_OP_NONE, PH_OP_BUY);
               }
               else if (Up_2Up_4Dn=="Buy" && p1[g]==PH_OP_BUY && p2[g]==PH_OP_BUY && p4[g]==PH_OP_SELL ) 
               { 
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_BUY, PH_OP_NONE, PH_OP_SELL);
               }
               else if (Up_3Dn_4Up=="Buy" && p1[g]==PH_OP_BUY && p3[g]==PH_OP_SELL && p4[g]==PH_OP_BUY ) 
               { 
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_NONE, PH_OP_SELL, PH_OP_BUY);
               }
               else if (Up_3Up_4Dn=="Buy" && p1[g]==PH_OP_BUY && p3[g]==PH_OP_BUY && p4[g]==PH_OP_SELL ) 
               { 
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_NONE, PH_OP_BUY, PH_OP_SELL);
               }
               // sell alerts
               if (p1[g]==PH_OP_SELL && p2[g]==PH_OP_SELL && p3[g]==PH_OP_SELL)
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_SELL, PH_OP_SELL, PH_OP_NONE);
               }
               else if (p1[g]==PH_OP_SELL && p2[g]==PH_OP_SELL && p4[g]==PH_OP_SELL)
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_SELL, PH_OP_NONE, PH_OP_SELL);
               }
               else if (p1[g]==PH_OP_SELL && p3[g]==PH_OP_SELL && p4[g]==PH_OP_SELL)
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_NONE, PH_OP_SELL, PH_OP_SELL);
               }
               else if (Dn_2Up_3Dn=="Sell" && p1[g]==PH_OP_SELL && p2[g]==PH_OP_BUY && p3[g]==PH_OP_SELL ) 
               { 
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_BUY, PH_OP_SELL, PH_OP_NONE);
               }
               
               else if (Dn_2Dn_3Up=="Sell" && p1[g]==PH_OP_SELL && p2[g]==PH_OP_SELL && p3[g]==PH_OP_BUY ) 
               { 
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_SELL, PH_OP_BUY, PH_OP_NONE);
               }
               else if (Dn_2Up_4Dn=="Sell" && p1[g]==PH_OP_SELL && p2[g]==PH_OP_BUY && p4[g]==PH_OP_SELL ) 
               { 
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_BUY, PH_OP_NONE, PH_OP_SELL);
               }
               else if (Dn_2Dn_4Up=="Sell" && p1[g]==PH_OP_SELL && p2[g]==PH_OP_SELL && p4[g]==PH_OP_BUY ) 
               { 
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_SELL, PH_OP_NONE, PH_OP_BUY);
               }
               else if (Dn_3Up_4Dn=="Sell" && p1[g]==PH_OP_SELL && p3[g]==PH_OP_BUY && p4[g]==PH_OP_SELL ) 
               { 
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_NONE, PH_OP_BUY, PH_OP_SELL);
               }
               else if (Dn_3Dn_4Up=="Sell" && p1[g]==PH_OP_SELL && p3[g]==PH_OP_SELL && p4[g]==PH_OP_BUY ) 
               { 
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_NONE, PH_OP_SELL, PH_OP_BUY);
               }
            }      
            else if (AlertNrOfTFs==2)
            {
               // buy alerts
               if (p1[g]==PH_OP_BUY && p2[g]==PH_OP_BUY)
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_BUY, PH_OP_NONE, PH_OP_NONE);
               }
               else if (p1[g]==PH_OP_BUY && p3[g]==PH_OP_BUY ) 
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_NONE, PH_OP_BUY, PH_OP_NONE);
               }
               else if (p1[g]==PH_OP_BUY && p4[g]==PH_OP_BUY)
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_NONE, PH_OP_NONE, PH_OP_BUY);
               }
               // sell alerts
               if (p1[g]==PH_OP_SELL && p2[g]==PH_OP_SELL)
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_SELL, PH_OP_NONE, PH_OP_NONE);
               }
               else if (p1[g]==PH_OP_SELL && p3[g]==PH_OP_SELL ) 
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_NONE, PH_OP_SELL, PH_OP_NONE);
               }
               else if (p1[g]==PH_OP_SELL && p4[g]==PH_OP_SELL)
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_NONE, PH_OP_NONE, PH_OP_SELL);
               }
            }      
            else if (AlertNrOfTFs == 1)
            {
               if (p1[g]==PH_OP_BUY)
               {
                  AlertDone = giveBuyAlert(PH_OP_BUY, PH_OP_NONE, PH_OP_NONE, PH_OP_NONE);
               }   
               else if (p1[g]==PH_OP_SELL)
               {
                  AlertDone = giveSellAlert(PH_OP_SELL, PH_OP_NONE, PH_OP_NONE, PH_OP_NONE);
               }   
            }      
            if (AlertDone) return (0);
         }
      }
//   }
}
string giveAlert(int p1,int p2,int p3,int p4)
{
   string AlertString = "";
   int total=0;
   if (p1!=PH_OP_NONE && AlertPeriod1)
   { 
      if (p1 == PH_OP_BUY) AlertString = AlertString  + "-(UP: ";
      else                 AlertString = AlertString  + "-(DOWN: ";
      AlertString = AlertString + givePerStr(period1) + ")-";
      total++;
   }
   if (p2!=PH_OP_NONE && AlertPeriod2)
   { 
      if (p2 == PH_OP_BUY) AlertString = AlertString  + "-(UP: ";
      else                 AlertString = AlertString  + "-(DOWN: ";
      AlertString = AlertString + givePerStr(period2) + ")-";
      total++;
   }
   if (p3!=PH_OP_NONE && AlertPeriod3)
   { 
      if (p3 == PH_OP_BUY) AlertString = AlertString  + "-(UP: ";
      else                 AlertString = AlertString  + "-(DOWN: ";
      AlertString = AlertString + givePerStr(period3) + ")-";
      total++;
   }
   if (p4!=PH_OP_NONE && AlertPeriod4)
   { 
      if (p4 == PH_OP_BUY) AlertString = AlertString  + "-(UP: ";
      else                 AlertString = AlertString  + "-(DOWN: ";
      AlertString = AlertString + givePerStr(period4) + ")-";
      total++;
   }
   if (total!=AlertNrOfTFs) AlertString="";
   return (AlertString);
}

bool giveBuyAlert(int p1,int p2,int p3,int p4)
{
   string tmp = giveAlert(p1,p2,p3,p4);
   bool   gaveAlert = false;
   if (StringLen(tmp)>0)
   {
      string tfs = " Timeframe";
      if (AlertNrOfTFs > 1) tfs = tfs + "s";
      string AlertString = Symbol()+"- Possible BUY: "+AlertNrOfTFs+tfs+": ";
      AlertString = AlertString + tmp;
      if (AlertOn)    Alert(AlertString); 
      if (SendMailOn) sendMail(AlertString);
      gaveAlert   = true;
   }   
   return (gaveAlert);
}

bool giveSellAlert(int p1,int p2,int p3,int p4)
{
   string tmp = giveAlert(p1,p2,p3,p4);
   bool   gaveAlert = false;
   if (StringLen(tmp)>0)
   {
      string tfs = " Timeframe";
      if (AlertNrOfTFs > 1) tfs = tfs + "s";
      string AlertString = Symbol()+"- Possible SELL: "+AlertNrOfTFs+tfs+": ";
      AlertString = AlertString + tmp;
      if (AlertOn)    Alert(AlertString); 
      if (SendMailOn) sendMail(AlertString);
      gaveAlert   = true;
   }   
   return (gaveAlert);
}

void sendMail(string PeriodDirection)
{
   SendMail("StochCrossOver",PeriodDirection);  
}

//+------------------------------------------------------------------+

