//+------------------------------------------------------------------+
//|                                          1M Stochastic Cross.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double LotSize = 2.0; 
extern double StopLossPips = 10;
extern double TakeProfitPips = 10;

double sl, tp;
double kline[3], dline[3];
bool crossedup, crosseddown;
int longtkt, shorttkt, cnt, t;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
      crossedup = false;
      crosseddown = false;
      t = 0;
      longtkt = -1;
      shorttkt = -1;
      cnt = 0;
      if((Point == 0.001) || (Point == 0.00001))
      {
         sl = 10*StopLossPips;
         tp = 10*TakeProfitPips;
      }
      else
      {
         sl = StopLossPips;
         tp = TakeProfitPips;
      }
      
  return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if(PositionOpen()) return(0);
   crossedup = false;
   crosseddown = false;

   for(int i = 0;i < 3;i++)
   {
      kline[i] = iStochastic(NULL, Period(), 8, 3, 3, MODE_SMA, 0, MODE_MAIN, i);
      dline[i] = iStochastic(NULL, Period(), 8, 3, 3, MODE_SMA, 0, MODE_SIGNAL, i); 
   }
   if ((kline[1] < dline[1]) && (kline[2] > dline[2])) crosseddown = true;
   else if ((kline[1] > dline[1]) && (kline[2] < dline[2])) crossedup = true;
   else return(0);
   if (crossedup && (kline[1] < 20.0)) GoLong();
   if (crosseddown && (kline[1] > 80.0)) GoShort();
    
   return(0);
  }
//+------------------------------------------------------------------+
int GoLong()
{
   longtkt = -1;
   cnt = 0;
   while((longtkt < 0) && (cnt < 20))
   {
      longtkt = OrderSend(Symbol(), OP_BUY, LotSize, Ask, 2, Ask-sl*Point,Ask+tp*Point, NULL, 55558, 0, Green);
      cnt++;
   }
   return(longtkt);
}

int GoShort()
{
   shorttkt = -1;
   cnt = 0;
   while((shorttkt < 0) && (cnt < 20))
   {
      shorttkt = OrderSend(Symbol(), OP_SELL, LotSize, Bid, 2, Bid+sl*Point, Bid-tp*Point, NULL, 55559, 0, Blue);
      cnt++;
   }
   return(shorttkt);
}



bool PositionOpen()
{
   t = OrdersTotal();
   for(int z = 0;z < t;z++)
   {
      OrderSelect(z, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol() == Symbol()) return(true);
   }
   return(false);
}