//+------------------------------------------------------------------+
//|                              TASC082008 - Premier Stochastic.mq4 |
//|                                Copyright  2008, Patrick Nouvion |
//|                                        http://www.mistigrifx.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Patrick Nouvion"
#property link      "http://www.mistigrifx.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Purple
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_level1 0.90
#property indicator_level2 0.20
#property indicator_level3 -0.20
#property indicator_level4 -0.90

extern int StochPeriod = 8;
//---- indicator buffers
double     BLUE[];
double      RED[];
double     LINE[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   //---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   
   IndicatorDigits(Digits);
   //---- indicator buffers mapping
   SetIndexBuffer(0,LINE);
   SetIndexBuffer(1,RED);
   SetIndexBuffer(2,BLUE);
   //---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Premier Stochastic");
   SetIndexLabel(0,"Premier Stochastic");
   //---- indicator levels
   SetLevelStyle( DRAW_SECTION, 1, DarkSlateGray );
   //---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() { return(0); }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   //---- last counted bar will be recounted
   int limit=Bars-6;
   double     Temp[];
   ArrayResize( Temp, limit );
   //---- 
   for(int i=0; i<limit; i++)
   { Temp[i] = ( iStochastic( Symbol(), 0, StochPeriod, 1, 1, MODE_SMA, PRICE_CLOSE, MODE_MAIN, i ) - 50.0 ) * 0.1; }
   ArraySetAsSeries( Temp, true );
   //---
   
   for(i=0; i<limit; i++)
   {
      double SMA = iMAOnArray( Temp, 0, 5, 0, MODE_SMA, i); 
      LINE[i] =  ( MathExp( SMA ) - 1 ) / ( MathExp( SMA ) + 1 );  
      if( LINE[i] >= 0 ) { BLUE[i] = LINE[i]; RED[i] = 0.0;     }
      else               { BLUE[i] = 0.0;     RED[i] = LINE[i]; }
   }
   //----
   return(0);
}
//+------------------------------------------------------------------+