//+------------------------------------------------------------------+
//|                                                      Channel.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  GPL General Public License"
#property link      "open source fx community"

#property indicator_chart_window include ""
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2

#property strict



extern int       ChannelPeriod = 21; 


//---- buffers
double UpLine[];
double DownLine[];
double upperArrowBuffer[];
double lowerArrowBuffer[];

int last   = 0;
int last_i = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,UpLine);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,DownLine);
   SetIndexBuffer(2,upperArrowBuffer);
   SetIndexBuffer(3,lowerArrowBuffer);   

//---- drawing settings
   SetIndexStyle( 
      2,             // line index 
      DRAW_ARROW,    // line type 
      EMPTY,         // line style 
      2,             // line width 
      Orange         // line color 
   );
   SetIndexArrow(2,218);
    
   SetIndexStyle( 
      3,             // line index 
      DRAW_ARROW,    // line type 
      EMPTY,         // line style 
      2,             // line width 
      Orange         // line color 
   );
   SetIndexArrow(3,217);

   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll();

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   string short_name = "test("+ITS(ChannelPeriod)+")";
   IndicatorShortName(ITS(ChannelPeriod));
   
   ObjectCreate("Wil's", OBJ_LABEL, 0,0,0);
   ObjectSet("Wil's", OBJPROP_CORNER, 3);
   ObjectSet("Wil's", OBJPROP_XDISTANCE,45);
   ObjectSet("Wil's", OBJPROP_YDISTANCE, 45);  
   ObjectSetText("Wil's", "Wil's ", 10, "Verdana", Black );

   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);      
  
   for (i = limit; i >= 0 ; i--)
   {
      
      UpLine[i] = High[ Highest(NULL, 0, MODE_HIGH, ChannelPeriod, i) ];            
      DownLine[i] = Low[ Lowest(NULL, 0, MODE_LOW, ChannelPeriod, i) ];
      
      
      if(High[i] == UpLine[i] && last <= 0 )
      {
         upperArrowBuffer[i]= 1.0003*High[i];  
         last = 1;
         last_i = i;
      }
      
      if(Low[i] == DownLine[i] && last >= 0 )
      {
         lowerArrowBuffer[i]= 0.9997*Low[i];
         last = -1;
         last_i = i;
      }

   }
//----

   if(last_i == 0)
   {
      if(last == 1)
      {
         Alert("High Channel Line Hit on " + Symbol() +" at "+ TTS(TimeCurrent()));
         last = 2;
      }   
      if(last == -1)
      {
         Alert("Low Channel Line Hit on " + Symbol() +" at "+ TTS(TimeCurrent()));  
         last = -2;
      }   
     
   }

   createLabel("Up", 20, 20, 1, DTS(UpLine[0],Digits),   12, "Arial", Lime) ;
   createLabel("Dn", 20, 40, 1, DTS(DownLine[0],Digits), 12, "Arial", Red)  ;

   return(0);
}
//+------------------------------------------------------------------+




//+----------------------------------------------------------------------------+
//| Create a text label.
//+----------------------------------------------------------------------------+
string createLabel(string argName, int x, int y, int corner, string text, int argFontSize, string argfont, color argColour) 
{
   if (argName == "") 
   {
      argName = "label_" + TTS(Time[0]);
   }
   if (ObjectFind(argName) == -1) 
   {
      ObjectCreate(argName, OBJ_LABEL, 0, 0, 0);
   }
   ObjectSet(argName, OBJPROP_COLOR, argColour);
   ObjectSet(argName, OBJPROP_CORNER, corner);
   ObjectSet(argName, OBJPROP_XDISTANCE, x);
   ObjectSet(argName, OBJPROP_YDISTANCE, y);
   ObjectSetText(argName, text, argFontSize,argfont);
   return(argName);
}


string ITS(int Value){return(IntegerToString(Value));}
string DTS(double Value,int Precision){return(DoubleToStr(Value,Precision));}
string TTS(datetime Value){return(TimeToString(Value));}







