//+------------------------------------------------------------------+
//|                                             MinMax indicator     |
//|                                                            Mikko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Mikko"
#property link      "noneOfYOurBusiness"

//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Gray
#property indicator_color2 Gray
#property indicator_color3 Red
#property indicator_color4 Yellow
#property indicator_color5 FireBrick

double high[];
double low[];
double middle[];
double buy[];
double sell[];

extern int count = 20; 
extern int xbars = 3;

int init() {

   IndicatorBuffers(5);
   SetIndexBuffer(0, high);   
   SetIndexStyle(0, DRAW_LINE, EMPTY, 1); 
   
   SetIndexBuffer(1, low);     
   SetIndexStyle(1, DRAW_LINE, EMPTY, 1);
   
   SetIndexBuffer(4, middle);     
   SetIndexStyle(1, DRAW_LINE, EMPTY, 1);

   SetIndexBuffer(2, buy);        
   SetIndexStyle(2, DRAW_ARROW, EMPTY, 1); 
   SetIndexArrow(2,217);
   
   SetIndexBuffer(3, sell);
   SetIndexStyle(3, DRAW_ARROW, EMPTY, 1);
   SetIndexArrow(3,218);
   
   IndicatorShortName("Mikko HighLow");
   
  // SetIndexDrawBegin(0, 0);  
   
   return(0);
}
  
int deinit() {
   return(0);
}
     
int start() {
       
   int counted_bars=IndicatorCounted();
  
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;

   int limit = Bars - counted_bars;
   for(int i = limit; i >= 0; i--) {
       double h = High[iHighest(NULL, 0, MODE_HIGH, count, i+1)];
       double l = Low[iLowest(NULL, 0, MODE_LOW, count, i+1)];
       double mid = (h+l)/2;
       
       high[i] = h;
       low[i] = l;
       middle[i] = mid;
       
       buy[i] = 0;
       sell[i] = 0;
     
       bool plot = true;
       if(High[i+xbars+1]==high[i+xbars+1-1]) {
         for(int j=1; j<=xbars; j++) {
            if(High[i+j] == high[i+j-1]) {
               plot = false;
               break;
            }
         }
         if(plot == true)  
            sell[i] = High[i];         
       }

       plot = true;
       if(Low[i+xbars+1]==low[i+xbars+1-1]) {
         for(j=1; j<=xbars; j++) {
            if(Low[i+j] == low[i+j-1]) {
               plot = false;
               break;
            }
         }
         if(plot == true)  
            buy[i] = Low[i];         
       }
   } 
   return(0);
}

