//+------------------------------------------------------------------+
//|                           Need 4 Speed Indicator N4S_Indy_01.mq4 |
//|                               Copyright  2015, Khalil Abokwaik. |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Khalil Abokwaik"
#property link "http://www.forexfactory.com/abokwaik"
#property description "Need4Speed Indicator v1 (copy under Indicators Folder)"
#property description "http://www.forexfactory.com/showthread.php?t=536931"
#property strict
#property indicator_chart_window
//----------------------------------------------------------------------------
input string   speed_options     =  "<<< SPEED SETTINGS >>>";//Speed Options
input int      speed_max         =  20;          //Speed Threshold (Points)
input int      speed_timer       =  1;          //Time (Seconds)
input string   timeframes        =  "<<< HIGHER TIME FRAMES >>>";//Higher Time Frames
input string   htf_1_code        = "M30"; //Higher Time Frame 1 Code 
input string   htf_2_code        = "H1"; //Higher Time Frame 2 Code 
input string   htf_3_code        = "H4"; //Higher Time Frame 3 Code 
input string   display_options   =  "<<< DISPLAY OPTIONS >>>";//Display Options
input int      speed_corner      =  1;         //Display Corner
input color    up_color          =  clrLimeGreen;       //Bullish Color 
input color    down_color        =  clrOrangeRed;//Bearish Color
input color    normal_color      =  clrLightGray;  //Normal Color
input string   font_name         =  "Arial"; //Font Name
input int      txt_font_size     =  10; //Text Font Size
input int      ob_font_size      =  8;        //On-Bar Font Size
input bool     play_sounds       =  True;       //Play Sounds
input bool     show_alerts       =  False;//Show Alerts
//----------------------------------------------------------------------------
double      prev_price =0.0;
int         prev_speed = 0;
int         zcorner = 0;
int         curr_speed = 0,up_signals=0,down_signals=0,max_bull_speed=0,max_bear_speed=0;
string      speed_label="speed_label";
string      mx_bull_speed="mx_bull_speed";
string      mx_bear_speed="mx_bear_speed";
int         up_lab_cnt =0;
int         down_lab_cnt =0,maxx_speed=0;
datetime    old_time=0;
int         pb_up=0,pb_down=0;
datetime    htf_1_time=0,htf_2_time=0,htf_3_time=0;
int         htf_1_bulls=0,htf_1_bears=0,htf_2_bulls=0,htf_2_bears=0,htf_3_bulls=0,htf_3_bears=0;
int         htf_1=0,htf_2=0,htf_3=0;
string      htf_0_code="";
//---------------------------------------------------

//---------------------------------------------------
void init()
{
   if(!EventSetTimer(speed_timer)) Alert("Error in Creating Timer");
   prev_price=0.0;
   prev_speed = 0;
   curr_speed = 0;
   max_bull_speed=0;
   max_bear_speed=0;
   htf_1 = string_to_TF(htf_1_code);
   htf_2 = string_to_TF(htf_2_code);
   htf_3 = string_to_TF(htf_3_code);
   htf_0_code=TF_to_string(Period());
   zcorner=MathMod(speed_corner,2);
   if(speed_corner==0 ||speed_corner==1)
   {
   Create_Label("tf0_lab",htf_0_code,30,20,speed_corner,MathAbs(150*zcorner-120),40,clrNONE,normal_color,font_name,txt_font_size,0,0);
   Create_Label("tf1_lab",htf_1_code,30,20,speed_corner,MathAbs(150*zcorner-90),40,clrNONE,normal_color,font_name,txt_font_size,0,0);
   Create_Label("tf2_lab",htf_2_code,30,20,speed_corner,MathAbs(150*zcorner-60),40,clrNONE,normal_color,font_name,txt_font_size,0,0);
   Create_Label("tf3_lab",htf_3_code,30,20,speed_corner,MathAbs(150*zcorner-30),40,clrNONE,normal_color,font_name,txt_font_size,0,0);
   Create_Label("tf0_bull","0",30,20,speed_corner,MathAbs(150*zcorner-120),60,clrNONE,up_color,font_name,txt_font_size,0,0);
   Create_Label("tf1_bull","0",30,20,speed_corner,MathAbs(150*zcorner-90),60,clrNONE,up_color,font_name,txt_font_size,0,0);
   Create_Label("tf2_bull","0",30,20,speed_corner,MathAbs(150*zcorner-60),60,clrNONE,up_color,font_name,txt_font_size,0,0);
   Create_Label("tf3_bull","0",30,20,speed_corner,MathAbs(150*zcorner-30),60,clrNONE,up_color,font_name,txt_font_size,0,0);
   Create_Label("tf0_bear","0",30,20,speed_corner,MathAbs(150*zcorner-120),80,clrNONE,down_color,font_name,txt_font_size,0,0);
   Create_Label("tf1_bear","0",30,20,speed_corner,MathAbs(150*zcorner-90),80,clrNONE,down_color,font_name,txt_font_size,0,0);
   Create_Label("tf2_bear","0",30,20,speed_corner,MathAbs(150*zcorner-60),80,clrNONE,down_color,font_name,txt_font_size,0,0);
   Create_Label("tf3_bear","0",30,20,speed_corner,MathAbs(150*zcorner-30),80,clrNONE,down_color,font_name,txt_font_size,0,0);
   }
   else
   {
   Create_Label("tf0_lab",htf_0_code,30,20,speed_corner,MathAbs(150*zcorner-120),80,clrNONE,normal_color,font_name,txt_font_size,0,0);
   Create_Label("tf1_lab",htf_1_code,30,20,speed_corner,MathAbs(150*zcorner-90),80,clrNONE,normal_color,font_name,txt_font_size,0,0);
   Create_Label("tf2_lab",htf_2_code,30,20,speed_corner,MathAbs(150*zcorner-60),80,clrNONE,normal_color,font_name,txt_font_size,0,0);
   Create_Label("tf3_lab",htf_3_code,30,20,speed_corner,MathAbs(150*zcorner-30),80,clrNONE,normal_color,font_name,txt_font_size,0,0);
   Create_Label("tf0_bull","0",30,20,speed_corner,MathAbs(150*zcorner-120),60,clrNONE,up_color,font_name,txt_font_size,0,0);
   Create_Label("tf1_bull","0",30,20,speed_corner,MathAbs(150*zcorner-90),60,clrNONE,up_color,font_name,txt_font_size,0,0);
   Create_Label("tf2_bull","0",30,20,speed_corner,MathAbs(150*zcorner-60),60,clrNONE,up_color,font_name,txt_font_size,0,0);
   Create_Label("tf3_bull","0",30,20,speed_corner,MathAbs(150*zcorner-30),60,clrNONE,up_color,font_name,txt_font_size,0,0);
   Create_Label("tf0_bear","0",30,20,speed_corner,MathAbs(150*zcorner-120),40,clrNONE,down_color,font_name,txt_font_size,0,0);
   Create_Label("tf1_bear","0",30,20,speed_corner,MathAbs(150*zcorner-90),40,clrNONE,down_color,font_name,txt_font_size,0,0);
   Create_Label("tf2_bear","0",30,20,speed_corner,MathAbs(150*zcorner-60),40,clrNONE,down_color,font_name,txt_font_size,0,0);
   Create_Label("tf3_bear","0",30,20,speed_corner,MathAbs(150*zcorner-30),40,clrNONE,down_color,font_name,txt_font_size,0,0);
   }
}
int start()
{
   return(1);
}
int deinit()
{
   EventKillTimer();
   delete_interface();   
   return(0);
   
}

void OnTimer()
  {
//---
  
   if(iTime(Symbol(),htf_1,0) > htf_1_time)
   {     
      htf_1_time=TimeCurrent();
      htf_1_bulls=0;
      htf_1_bears=0;      
   }
   if(iTime(Symbol(),htf_2,0) > htf_2_time)
   {     
      htf_2_time=TimeCurrent();
      htf_2_bulls=0;
      htf_2_bears=0;      
   }
   if(iTime(Symbol(),htf_3,0) > htf_3_time)
   {     
      htf_3_time=TimeCurrent();
      htf_3_bulls=0;
      htf_3_bears=0;      
   }

   if(Time[0]>old_time)
   {
      if(old_time==0 || up_signals>0) up_lab_cnt=up_lab_cnt+1;
      if(old_time==0 || down_signals>0) down_lab_cnt=down_lab_cnt+1;
      old_time=TimeCurrent();      
      up_signals=0;
      down_signals=0;
   }
   RefreshRates();
   if(prev_price==0.0)
   {
      prev_price=MarketInfo(Symbol(),MODE_BID);
      prev_speed=0;
      curr_speed=0;
   }
   else
   {
      prev_speed=curr_speed;
      curr_speed=(MarketInfo(Symbol(),MODE_BID)-prev_price)/Point;
      prev_price=MarketInfo(Symbol(),MODE_BID);
   } 
   if(curr_speed>1000 || curr_speed<-1000) curr_speed=0;
   if(curr_speed>speed_max) 
   { 
         ObjectSetInteger(0,speed_label,OBJPROP_COLOR,up_color);
         if (!show_alerts && play_sounds) PlaySound("alert.wav");
         if(show_alerts) Alert(Symbol()," Bull Impulse"); 
         up_signals=up_signals+(curr_speed/speed_max);
         htf_1_bulls = htf_1_bulls + (curr_speed/speed_max);
         htf_2_bulls = htf_2_bulls + (curr_speed/speed_max);
         htf_3_bulls = htf_3_bulls + (curr_speed/speed_max);
         ObjectSetString(0,"tf0_bull",OBJPROP_TEXT,up_signals);
         ObjectSetString(0,"tf1_bull",OBJPROP_TEXT,htf_1_bulls);
         ObjectSetString(0,"tf2_bull",OBJPROP_TEXT,htf_2_bulls);
         ObjectSetString(0,"tf3_bull",OBJPROP_TEXT,htf_3_bulls);
         if(ObjectFind(0,StringConcatenate("up_lab_",up_lab_cnt))==0)
         {
            ObjectSetString(0,StringConcatenate("up_lab_",up_lab_cnt),OBJPROP_TEXT,up_signals);
            ObjectSetDouble(0,StringConcatenate("up_lab_",up_lab_cnt),OBJPROP_PRICE,Low[0]-(High[0]-Low[0])/2);
         }
         else
         Create_Label(StringConcatenate("up_lab_",up_lab_cnt),up_signals,10,10,0,0,0,clrNONE,up_color,font_name,ob_font_size,Time[0],Low[0]-(High[0]-Low[0])/2);
         
   }
   if(curr_speed<-1*speed_max) 
   { 
         
         ObjectSetInteger(0,speed_label,OBJPROP_COLOR,down_color);
         if (!show_alerts && play_sounds) PlaySound("alert2.wav");
         if(show_alerts) Alert(Symbol()," Bearish Impulse");          
         down_signals=down_signals+MathAbs(curr_speed/speed_max);
         htf_1_bears=htf_1_bears+MathAbs(curr_speed/speed_max);
         htf_2_bears=htf_2_bears+MathAbs(curr_speed/speed_max);
         htf_3_bears=htf_3_bears+MathAbs(curr_speed/speed_max);
         ObjectSetString(0,"tf0_bear",OBJPROP_TEXT,down_signals);
         ObjectSetString(0,"tf1_bear",OBJPROP_TEXT,htf_1_bears);
         ObjectSetString(0,"tf2_bear",OBJPROP_TEXT,htf_2_bears);
         ObjectSetString(0,"tf3_bear",OBJPROP_TEXT,htf_3_bears);
         if(ObjectFind(0,StringConcatenate("down_lab_",down_lab_cnt))==0)
         {
            ObjectSetString(0,StringConcatenate("down_lab_",down_lab_cnt),OBJPROP_TEXT,down_signals);
            ObjectSetDouble(0,StringConcatenate("down_lab_",down_lab_cnt),OBJPROP_PRICE,High[0]+(High[0]-Low[0])/2);
         }
         else
         {
            Create_Label(StringConcatenate("down_lab_",down_lab_cnt),down_signals,10,10,0,0,0,clrNONE,down_color,font_name,ob_font_size,Time[0],High[0]+(High[0]-Low[0])/2);
            ObjectSetInteger(0,StringConcatenate("down_lab_",down_lab_cnt),OBJPROP_ANCHOR,ANCHOR_LOWER);
         }
   }
   //-- update TF names color
   if(up_signals>down_signals) ObjectSetInteger(0,"tf0_lab",OBJPROP_COLOR,up_color);
   if(up_signals<down_signals) ObjectSetInteger(0,"tf0_lab",OBJPROP_COLOR,down_color);
   if(up_signals==down_signals) ObjectSetInteger(0,"tf0_lab",OBJPROP_COLOR,normal_color);

   if(htf_1_bulls>htf_1_bears) ObjectSetInteger(0,"tf1_lab",OBJPROP_COLOR,up_color);
   if(htf_1_bulls<htf_1_bears) ObjectSetInteger(0,"tf1_lab",OBJPROP_COLOR,down_color);
   if(htf_1_bulls==htf_1_bears) ObjectSetInteger(0,"tf1_lab",OBJPROP_COLOR,normal_color);

   if(htf_2_bulls>htf_2_bears) ObjectSetInteger(0,"tf2_lab",OBJPROP_COLOR,up_color);
   if(htf_2_bulls<htf_2_bears) ObjectSetInteger(0,"tf2_lab",OBJPROP_COLOR,down_color);
   if(htf_2_bulls==htf_2_bears) ObjectSetInteger(0,"tf2_lab",OBJPROP_COLOR,normal_color);

   if(htf_3_bulls>htf_3_bears) ObjectSetInteger(0,"tf3_lab",OBJPROP_COLOR,up_color);
   if(htf_3_bulls<htf_3_bears) ObjectSetInteger(0,"tf3_lab",OBJPROP_COLOR,down_color);
   if(htf_3_bulls==htf_3_bears) ObjectSetInteger(0,"tf3_lab",OBJPROP_COLOR,normal_color);

   ChartRedraw();
  }
//+------------------------------------------------------------------+

void Create_Label(string lbl_name,string label,int xsize,int ysize,int corner,int xdist,int ydist,int bcolor,int fcolor,
                  string font,int font_size,datetime dt, double price)
{
   if(ObjectFind(0,lbl_name)<0)
   {
      if(price==0) ObjectCreate(0,lbl_name,OBJ_LABEL,0,dt,price);
      else         ObjectCreate(0,lbl_name,OBJ_TEXT,0,dt,price);

      ObjectSetString(0,lbl_name,OBJPROP_TEXT,label);
      ObjectSetString(0,lbl_name,OBJPROP_FONT,font);
      ObjectSetInteger(0,lbl_name,OBJPROP_XSIZE,xsize);
      ObjectSetInteger(0,lbl_name,OBJPROP_ANCHOR,xsize);
      ObjectSetInteger(0,lbl_name,OBJPROP_YSIZE,ysize);
      ObjectSetInteger(0,lbl_name,OBJPROP_CORNER,corner);     
      ObjectSetInteger(0,lbl_name,OBJPROP_XDISTANCE,xdist);      
      ObjectSetInteger(0,lbl_name,OBJPROP_YDISTANCE,ydist);         
      ObjectSetInteger(0,lbl_name,OBJPROP_COLOR,fcolor);
      ObjectSetInteger(0,lbl_name,OBJPROP_FONTSIZE,font_size);
      ChartRedraw();      
   }

}



int string_to_TF(string tfs)
{
   int tf=0;
         if (tfs=="M1" || tfs=="1"     ||tfs=="m1")   tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5"     ||tfs=="m5")   tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15"    ||tfs=="m15")  tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30"    ||tfs=="m30")  tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60"    ||tfs=="h1")   tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240"   ||tfs=="h4")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440"  ||tfs=="d1")   tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080" ||tfs=="w1")   tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200" ||tfs=="mn")   tf=PERIOD_MN1;
         if (tf==0)               tf=Period();
   return(tf);
}
string TF_to_string(int tfs)
{
   string tf="";
   if (tfs==1) tf="M1";
   if (tfs==5) tf="M5";
   if (tfs==15) tf="M15";
   if (tfs==30) tf="M30";
   if (tfs==60) tf="H1";
   if (tfs==240) tf="H4";
   if (tfs==1440) tf="D1";
   if (tfs==10080) tf="W1";
   if (tfs==43200) tf="MN1";
   return(tf);
}
void delete_interface()
{
   int obj_total=ObjectsTotal();
   for(int i=obj_total-1;i>=0;i--)
   {
      if(StringSubstr(ObjectName(i),0,3)=="mx_"
      || StringSubstr(ObjectName(i),0,3)=="spe"
      || StringSubstr(ObjectName(i),0,2)=="tf"
      || StringSubstr(ObjectName(i),0,3)=="up_"
      || StringSubstr(ObjectName(i),0,5)=="down_"
      )
      
         ObjectDelete(ObjectName(i));
   }
   return;
}