//+------------------------------------------------------------------+
//|                                                Price(%)Range.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//|                              https://www.mql5.com/en/users/3rjfx |
//+------------------------------------------------------------------+
#property copyright "https://www.mql5.com/en/users/3rjfx. ~ By 3rjfx ~ Created: 2015/12/20"
#property link      "http://www.mql5.com"
#property link      "https://www.mql5.com/en/users/3rjfx"
#property version   "1.00"
#property description "Price(%)Range is the indicator for the MT4, which calculates the price movement"
#property description "based on percentage High (Highest) and Low (Lowest) price on 100 bars."
//--
//---
#property indicator_separate_window
#property indicator_buffers 9
//--- 
extern    ENUM_APPLIED_PRICE Price  = PRICE_TYPICAL; // Price
extern    bool          SoundAlerts = true;
extern    bool          MsgAlerts   = true;
extern    bool          eMailAlerts = false;
extern    string     SoundAlertFile = "alert.wav";
extern    color         MoveUpColor = clrBlue;
extern    color       MoveDownColor = clrRed;
extern    color  WaitDirectionColor = clrYellow;
extern    color       MoveLinkColor = clrAqua;
extern    color           TextColor = clrSnow;
extern    color        RoundedColor = clrYellow;
extern   color BorderlinePricesRise = clrBlue;
extern   color BorderlinePricesDown = clrRed;
extern   int          LineWidthSize = 1;
//--
//--- the Main arrays buffers
double ExtCPRBuffer[];
double ExtHPRBuffer[];
double ExtMHPRBuffer[];
double ExtMDPBuffer[];
double ExtMLPRBuffer[];
double ExtLPRBuffer[];
double ExtEMABuffer[];
double ExtEMABuffUp[];
double ExtEMABuffDn[];
double ema04[];
double ema24[];
double ema39[];
//--
double cph;
double cpl;
double cpr0;
double cpr1;
//--
//--- spacing &  coordinate
int scaleYt=18;
int offsetX=171;
int offsetY=3;
int fontSize=9;
//--- bars maximum for calculation
int DATA_LIMIT;
int hilo;
int limit;
int pos;
//--
int cal;
int pal;
int cmnt;
int pmnt;
//--
long chart_ID;
string short_name;
string alBase,alSubj,alMsg;
//---
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffer mapping
   IndicatorBuffers(9);
//--
   short_name=StringConcatenate("Price(%R,",_Symbol,",TF:",strTF(_Period),")");
   chart_ID=ChartID();
   DATA_LIMIT=1+(int)WindowBarsPerChart();
   limit=DATA_LIMIT-1;
   hilo=100;
   pos=0;
//--- set levels - color - levelstyle
   IndicatorSetInteger(INDICATOR_LEVELS,4);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,23.6);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,38.2);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,61.8);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,3,76.4);
//--
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,clrLightSlateGray);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,STYLE_SOLID);
//--- set maximum and minimum for subwindow 
   IndicatorSetDouble(INDICATOR_MINIMUM,0);
   IndicatorSetDouble(INDICATOR_MAXIMUM,100);
//--
//---
   SetIndexBuffer(0,ExtEMABuffer); // Moving Average 39
   SetIndexBuffer(1,ExtCPRBuffer);  // Current Price%R value
   SetIndexBuffer(2,ExtHPRBuffer);  // High Price%R value
   SetIndexBuffer(3,ExtMHPRBuffer);  // Medium High Price%R value
   SetIndexBuffer(4,ExtMDPBuffer);  // Medium Price%R value
   SetIndexBuffer(5,ExtMLPRBuffer);  // Medium Low Price%R value
   SetIndexBuffer(6,ExtLPRBuffer);  // Low Price%R value
   SetIndexBuffer(7,ExtEMABuffUp);  // Moving Average 39 Up
   SetIndexBuffer(8,ExtEMABuffDn);  // Moving Average 39 Down
//-- indicator drawing shape styles
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,EMPTY,MoveLinkColor);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,LineWidthSize,MoveLinkColor);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,EMPTY,MoveUpColor);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,EMPTY,MoveUpColor);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,EMPTY,WaitDirectionColor);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,EMPTY,MoveDownColor);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,EMPTY,MoveDownColor);
   SetIndexStyle(7,DRAW_LINE,STYLE_SOLID,2,BorderlinePricesRise);
   SetIndexStyle(8,DRAW_LINE,STYLE_SOLID,2,BorderlinePricesDown);
//--
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,"Price(%)R");
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   SetIndexLabel(7,"(%R)Ups");
   SetIndexLabel(8,"(%R)Down");
//--
   IndicatorDigits(_Digits);
   IndicatorShortName(short_name);
//--
//--- last bar counting position
   ArrayResize(ExtCPRBuffer,DATA_LIMIT);
   ArrayResize(ExtHPRBuffer,DATA_LIMIT);
   ArrayResize(ExtMHPRBuffer,DATA_LIMIT);
   ArrayResize(ExtMDPBuffer,DATA_LIMIT);
   ArrayResize(ExtMLPRBuffer,DATA_LIMIT);
   ArrayResize(ExtLPRBuffer,DATA_LIMIT);
   ArrayResize(ExtEMABuffer,DATA_LIMIT);
   ArrayResize(ExtEMABuffUp,DATA_LIMIT);
   ArrayResize(ExtEMABuffDn,DATA_LIMIT);
   ArrayResize(ema04,DATA_LIMIT);
   ArrayResize(ema24,DATA_LIMIT);
   ArrayResize(ema39,DATA_LIMIT);
//--
   ArraySetAsSeries(ExtCPRBuffer,true);
   ArraySetAsSeries(ExtHPRBuffer,true);
   ArraySetAsSeries(ExtMHPRBuffer,true);
   ArraySetAsSeries(ExtMDPBuffer,true);
   ArraySetAsSeries(ExtMLPRBuffer,true);
   ArraySetAsSeries(ExtLPRBuffer,true);
   ArraySetAsSeries(ExtEMABuffer,true);
   ArraySetAsSeries(ExtEMABuffUp,true);
   ArraySetAsSeries(ExtEMABuffDn,true);
   ArraySetAsSeries(ema04,true);
   ArraySetAsSeries(ema24,true);
   ArraySetAsSeries(ema39,true);
//--
//--- initialization done
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----
   ObjectsDeleteAll();
   GlobalVariablesDeleteAll();
//----
   return;
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//----
int start()
  {
//----
//--
   int i;
   int x=1;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   if(counted_bars==0)
     {
      DATA_LIMIT=1+(int)WindowBarsPerChart();
      limit=DATA_LIMIT-1;
     }
//--
   ResetLastError();
   RefreshRates();
   cal=0;
//---
//--
   for(i=DATA_LIMIT-1; i>=pos; i--)
     {ema04[i]=iMA(_Symbol,0,4,0,1,5,i);}
   for(i=DATA_LIMIT-1; i>=pos; i--)
     {ema24[i]=iMAOnArray(ema04,0,24,0,1,i);}
   for(i=DATA_LIMIT-1; i>=pos; i--)
     {ema39[i]=iMAOnArray(ema24,0,39,0,1,i);}
//--
   int inH=iHighest(_Symbol,0,MODE_HIGH,hilo,pos);
   int inL=iLowest(_Symbol,0,MODE_LOW,hilo,pos);
   if(inH!=-1) cph=iHigh(_Symbol,0,inH);
   if(inL!=-1) cpl=iLow(_Symbol,0,inL);
//--
   double ma240=((ema24[0]-cpl)/(cph-cpl))*100;
   double ema40=((ema04[0]-cpl)/(cph-cpl))*100;
   double ema41=((ema04[1]-cpl)/(cph-cpl))*100;
//--
//----
   for(i=DATA_LIMIT-1; i>=pos; i--)
     {
      //---
      switch(Price)
        {
         case 0:
            cpr0=Close[i];
            cpr1=Close[i+1];
            break;
         case 1:
            cpr0=Open[i];
            cpr1=Open[i+1];
            break;
         case 2:
            cpr0=High[i];
            cpr1=High[i+1];
            break;
         case 3:
            cpr0=Low[i];
            cpr1=Low[i+1];
            break;
         case 4:
            cpr0=(High[i]+Low[i])/2;
            cpr1=(High[i+1]+Low[i+1])/2;
            break;
         case 5:
            cpr0=(High[i]+Low[i]+Close[i])/3;
            cpr1=(High[i+1]+Low[i+1]+Close[i+1])/3;
            break;
         case 6:
            cpr0=(High[i]+Low[i]+Close[i]+Close[i])/4;
            cpr1=(High[i+1]+Low[i+1]+Close[i+1]+Close[i+1])/4;
            break;
        }
      //--
      ExtCPRBuffer[i]=((cpr0-cpl)/(cph-cpl))*100;
      ExtEMABuffer[i]=((ema39[i]-cpl)/(cph-cpl))*100;
      if(ema40>ExtEMABuffer[i]) {ExtEMABuffUp[i]=ExtEMABuffer[i]; ExtEMABuffDn[i]=EMPTY_VALUE;}
      if(ema40<ExtEMABuffer[i]) {ExtEMABuffDn[i]=ExtEMABuffer[i]; ExtEMABuffUp[i]=EMPTY_VALUE;}
      if((ma240>ExtEMABuffer[i])&&(ema40>ema41)) {ExtEMABuffUp[i]=ExtEMABuffer[i]; ExtEMABuffDn[i]=EMPTY_VALUE;}
      if((ma240<ExtEMABuffer[i])&&(ema40<ema41)) {ExtEMABuffDn[i]=ExtEMABuffer[i]; ExtEMABuffUp[i]=EMPTY_VALUE;}
      //--
      if((ExtCPRBuffer[i]>=76.4) && (ExtCPRBuffer[i]<100.0))
        {
         ExtHPRBuffer[i]=ExtCPRBuffer[i];
         ExtMHPRBuffer[i]=EMPTY_VALUE;
         ExtMDPBuffer[i]=EMPTY_VALUE;
         ExtMLPRBuffer[i]=EMPTY_VALUE;
         ExtLPRBuffer[i]=EMPTY_VALUE;
         MoveLinkColor=MoveUpColor;
        }
      else if((ExtCPRBuffer[i]>=61.8) && (ExtCPRBuffer[i]<76.4))
        {
         ExtHPRBuffer[i]=EMPTY_VALUE;
         ExtMHPRBuffer[i]=ExtCPRBuffer[i];
         ExtMDPBuffer[i]=EMPTY_VALUE;
         ExtMLPRBuffer[i]=EMPTY_VALUE;
         ExtLPRBuffer[i]=EMPTY_VALUE;
         MoveLinkColor=MoveUpColor;
        }
      else if((ExtCPRBuffer[i]>=38.2) && (ExtCPRBuffer[i]<61.8))
        {
         ExtHPRBuffer[i]=EMPTY_VALUE;
         ExtMHPRBuffer[i]=EMPTY_VALUE;
         ExtMDPBuffer[i]=ExtCPRBuffer[i];
         ExtMLPRBuffer[i]=EMPTY_VALUE;
         ExtLPRBuffer[i]=EMPTY_VALUE;
         MoveLinkColor=WaitDirectionColor;
        }
      else if((ExtCPRBuffer[i]>=23.6) && (ExtCPRBuffer[i]<38.2))
        {
         ExtHPRBuffer[i]=EMPTY_VALUE;
         ExtMHPRBuffer[i]=EMPTY_VALUE;
         ExtMDPBuffer[i]=EMPTY_VALUE;
         ExtMLPRBuffer[i]=ExtCPRBuffer[i];
         ExtLPRBuffer[i]=EMPTY_VALUE;
         MoveLinkColor=MoveDownColor;
        }
      else if((ExtCPRBuffer[i]>=0.0) && (ExtCPRBuffer[i]<23.6))
        {
         ExtHPRBuffer[i]=EMPTY_VALUE;
         ExtMHPRBuffer[i]=EMPTY_VALUE;
         ExtMDPBuffer[i]=EMPTY_VALUE;
         ExtMLPRBuffer[i]=EMPTY_VALUE;
         ExtLPRBuffer[i]=ExtCPRBuffer[i];
         MoveLinkColor=MoveDownColor;
        }
      //--
      //---
      if(i==0)
        {
         //---
         if(ExtCPRBuffer[i]>ExtCPRBuffer[i+1])
           {
            //--
            ObjectDelete("txCons"+x);
            ObjectDelete("txCons"+x+"a");
            ObjectDelete("txCons"+x+"a"+"1");
            //--
            ObjectCreate(chart_ID,"txCons"+x,OBJ_LABEL,WindowFind(short_name),0,0);
            ObjectSetText("txCons"+x,CharToStr(164),25,"Wingdings",RoundedColor);
            ObjectSetInteger(chart_ID,"txCons"+x,OBJPROP_CORNER,1);
            ObjectSetInteger(chart_ID,"txCons"+x,OBJPROP_XDISTANCE,offsetX-6);
            ObjectSetInteger(chart_ID,"txCons"+x,OBJPROP_YDISTANCE,1*scaleYt+offsetY+19);
            //--
            ObjectCreate(chart_ID,"txCons"+x+"a",OBJ_LABEL,WindowFind(short_name),0,0);
            ObjectSetText("txCons"+x+"a",CharToStr(217),18,"Wingdings",MoveLinkColor);
            ObjectSetInteger(chart_ID,"txCons"+x+"a",OBJPROP_CORNER,1);
            ObjectSetInteger(chart_ID,"txCons"+x+"a",OBJPROP_XDISTANCE,offsetX-11);
            ObjectSetInteger(chart_ID,"txCons"+x+"a",OBJPROP_YDISTANCE,0*scaleYt+offsetY+24);
            //--
            if(cpr0>cpr1)
              {
               ObjectCreate(chart_ID,"txCons"+x+"a"+"1",OBJ_LABEL,WindowFind(short_name),0,0);
               ObjectSetText("txCons"+x+"a"+"1","UP",6,"Bodoni MT Black",TextColor);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_CORNER,1);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_XDISTANCE,offsetX-14);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_YDISTANCE,2*scaleYt+offsetY+33);
              }
            //--
            else
              {
               ObjectCreate(chart_ID,"txCons"+x+"a"+"1",OBJ_LABEL,WindowFind(short_name),0,0);
               ObjectSetText("txCons"+x+"a"+"1","WAIT",6,"Bodoni MT Black",TextColor);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_CORNER,1);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_XDISTANCE,offsetX-11);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_YDISTANCE,2*scaleYt+offsetY+33);
              }
           }
         //---
         else if(ExtCPRBuffer[i]<ExtCPRBuffer[i+1])
           {
            //--
            ObjectDelete("txCons"+x);
            ObjectDelete("txCons"+x+"a");
            ObjectDelete("txCons"+x+"a"+"1");
            //--
            ObjectCreate(chart_ID,"txCons"+x,OBJ_LABEL,WindowFind(short_name),0,0);
            ObjectSetText("txCons"+x,CharToStr(164),25,"Wingdings",RoundedColor);
            ObjectSetInteger(chart_ID,"txCons"+x,OBJPROP_CORNER,1);
            ObjectSetInteger(chart_ID,"txCons"+x,OBJPROP_XDISTANCE,offsetX-11);
            ObjectSetInteger(chart_ID,"txCons"+x,OBJPROP_YDISTANCE,1*scaleYt+offsetY+19);
            //--
            ObjectCreate(chart_ID,"txCons"+x+"a",OBJ_LABEL,WindowFind(short_name),0,0);
            ObjectSetText("txCons"+x+"a",CharToStr(218),18,"Wingdings",MoveLinkColor);
            ObjectSetInteger(chart_ID,"txCons"+x+"a",OBJPROP_CORNER,1);
            ObjectSetInteger(chart_ID,"txCons"+x+"a",OBJPROP_XDISTANCE,offsetX-15);
            ObjectSetInteger(chart_ID,"txCons"+x+"a",OBJPROP_YDISTANCE,2*scaleYt+offsetY+22);
            //--
            if(cpr0<cpr1)
              {
               ObjectCreate(chart_ID,"txCons"+x+"a"+"1",OBJ_LABEL,WindowFind(short_name),0,0);
               ObjectSetText("txCons"+x+"a"+"1","DOWN",6,"Bodoni MT Black",TextColor);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_CORNER,1);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_XDISTANCE,offsetX-11);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_YDISTANCE,0*scaleYt+offsetY+31);
              }
            //--
            else
              {
               ObjectCreate(chart_ID,"txCons"+x+"a"+"1",OBJ_LABEL,WindowFind(short_name),0,0);
               ObjectSetText("txCons"+x+"a"+"1","WAIT",6,"Bodoni MT Black",TextColor);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_CORNER,1);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_XDISTANCE,offsetX-9);
               ObjectSetInteger(chart_ID,"txCons"+x+"a"+"1",OBJPROP_YDISTANCE,0*scaleYt+offsetY+31);
              }
           }
         //---
         if((ema41<=ExtEMABuffer[i+1])&&(ema40>ExtEMABuffer[i])&&(cpr0>cpr1)&&(ExtEMABuffUp[i]!=EMPTY_VALUE)) {cal=391;}
         if((ema41>=ExtEMABuffer[i+1])&&(ema40<ExtEMABuffer[i])&&(cpr0<cpr1)&&(ExtEMABuffDn[i]!=EMPTY_VALUE)) {cal=390;}
         if((ema40>ExtEMABuffer[i])&&(ExtCPRBuffer[i]<80.0)&&(cpr0>cpr1)&&(ema40>ema41)&&(ExtEMABuffUp[i]!=EMPTY_VALUE)) {cal=393;}
         if((ema40<ExtEMABuffer[i])&&(ExtCPRBuffer[i]>20.0)&&(cpr0<cpr1)&&(ema40<ema41)&&(ExtEMABuffDn[i]!=EMPTY_VALUE)) {cal=392;}
         if((ExtCPRBuffer[i+1]<23.6)&&(ExtCPRBuffer[i]>23.6)&&(ExtEMABuffer[i]>38.2)&&(cpr0>cpr1)) {cal=395;}
         if((ExtCPRBuffer[i+1]>76.4)&&(ExtCPRBuffer[i]<76.4)&&(ExtEMABuffer[i]<61.8)&&(cpr0<cpr1)) {cal=394;}
         if((ExtCPRBuffer[i]<23.6)&&(inL<inH)&&(ExtEMABuffer[i]>61.8)&&(ema40>ema41)&&(cpr0>cpr1)) {cal=397;}
         if((ExtCPRBuffer[i]>76.4)&&(inH<inL)&&(ExtEMABuffer[i]<38.2)&&(ema40<ema41)&&(cpr0<cpr1)) {cal=396;}
         //---
        }
      //---
     }
//---
   ChartRedraw(0);
   RefreshRates();
   p_alerts(cal);
//---
//--- done!
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Do_Alerts(string msgText,string eMailSub)
  {
//--
   if(MsgAlerts) Alert(msgText);
   if(SoundAlerts) PlaySound(SoundAlertFile);
   if(eMailAlerts) SendMail(eMailSub,msgText);
//--
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string strTF(int period)
  {
   switch(period)
     {
      //--
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN");
      //--
     }
   return(period);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void p_alerts(int alert)
  {
//--
   cmnt=(int)Minute();
   if(cmnt!=pmnt)
     {
      //---
      //--
      if((cal!=pal) && (alert==391))
        {
         alBase=StringConcatenate(short_name," ",_Symbol,", TF: ",strTF(_Period)," @ ",TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
         alSubj=StringConcatenate(alBase,". The Price Goes Up,");
         alMsg=StringConcatenate(alSubj," Action: Open BUY.!!");
         pmnt=cmnt;
         pal=cal;
         Do_Alerts(alMsg,alSubj);
        }
      //--
      if((cal!=pal) && (alert==390))
        {
         alBase=StringConcatenate(short_name," ",_Symbol,", TF: ",strTF(_Period)," @ ",TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
         alSubj=StringConcatenate(alBase,". The Price Goes Down,");
         alMsg=StringConcatenate(alSubj," Action: Open SELL.!!");
         pmnt=cmnt;
         pal=cal;
         Do_Alerts(alMsg,alSubj);
        }
      //--
      if((cal!=pal) && (alert==393))
        {
         alBase=StringConcatenate(short_name," ",_Symbol,", TF: ",strTF(_Period)," @ ",TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
         alSubj=StringConcatenate(alBase,". The Price Goes Up,");
         alMsg=StringConcatenate(alSubj," Action: Open BUY.!!");
         pmnt=cmnt;
         pal=cal;
         Do_Alerts(alMsg,alSubj);
        }
      //--
      if((cal!=pal) && (alert==392))
        {
         alBase=StringConcatenate(short_name," ",_Symbol,", TF: ",strTF(_Period)," @ ",TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
         alSubj=StringConcatenate(alBase,". The Price Goes Down,");
         alMsg=StringConcatenate(alSubj," Action: Open SELL.!!");
         pmnt=cmnt;
         pal=cal;
         Do_Alerts(alMsg,alSubj);
        }
      //--
      if((cal!=pal) && (alert==395))
        {
         alBase=StringConcatenate(short_name," ",_Symbol,", TF: ",strTF(_Period)," @ ",TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
         alSubj=StringConcatenate(alBase,". The Price Goes Up,");
         alMsg=StringConcatenate(alSubj," Action: Open BUY.!!");
         pmnt=cmnt;
         pal=cal;
         Do_Alerts(alMsg,alSubj);
        }
      //--
      if((cal!=pal) && (alert==394))
        {
         alBase=StringConcatenate(short_name," ",_Symbol,", TF: ",strTF(_Period)," @ ",TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
         alSubj=StringConcatenate(alBase,". The Price Goes Down,");
         alMsg=StringConcatenate(alSubj," Action: Open SELL.!!");
         pmnt=cmnt;
         pal=cal;
         Do_Alerts(alMsg,alSubj);
        }
      //--
      if((cal!=pal) && (alert==397))
        {
         alBase=StringConcatenate(short_name," ",_Symbol,", TF: ",strTF(_Period)," @ ",TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
         alSubj=StringConcatenate(alBase,". The Price Goes Up,");
         alMsg=StringConcatenate(alSubj," Action: Open BUY.!!");
         pmnt=cmnt;
         pal=cal;
         Do_Alerts(alMsg,alSubj);
        }
      //--
      if((cal!=pal) && (alert==396))
        {
         alBase=StringConcatenate(short_name," ",_Symbol,", TF: ",strTF(_Period)," @ ",TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
         alSubj=StringConcatenate(alBase,". The Price Goes Down,");
         alMsg=StringConcatenate(alSubj," Action: Open SELL.!!");
         pmnt=cmnt;
         pal=cal;
         Do_Alerts(alMsg,alSubj);
        }
      //--
      //---
     }
//--
   return;
//--
//----
  } //-end p_alerts()
//---/
//+------------------------------------------------------------------+
